<%
' These variables will be available to all scripts.

Const APPNAME = "Mailboxsize"
Const ISWAP = False
Const VERSION = "4"
Const BRTEXT = "<br>"
Const DEFSUBJECTWIDTH = 10
Const DEFADDRSPERPAGE = 50
Const DEFAPPTSPERPAGE = 10
Const DEFMAXPAGESIZE = 2000
Const DEFMSGSPERPAGE = 10
Const DEFNOTESPERPAGE = 10
Const DEFTASKSPERPAGE = 10
Const SHOWDEBUGONFAIL = True
Const UNDERLINETEXT = "<hr>"

Dim ac0, ad0
Dim ai0 ' PDA only
Dim al0, at0
Dim ci0
Dim dt0 ' WAP only
Dim em0 ' PDA only
Dim fi0, fl0
Dim fl1 ' PDA only
Dim fl2, fl3
Dim fn0, fn1 ' WAP only
Dim hb0 ' PDA only
Dim hm0 ' WAP only
Dim mb0, md0, mi0
Dim mo0, dy0, yr0 ' PDA only
Dim mn0, mr0, mt0, pg0, pg1, re0, rs0, ry0
Dim sh0 ' PDA only
Dim si0, st0
Dim th0 ' PDA only
Dim tz0, tz1
Dim vd0 ' PDA only

Dim arrProxyAddresses

Dim blnDebug
Dim blnExpandFolders, blnExpandPublicFolders ' PDA only
Dim blnMarkAsRead
Dim blnMultipleMarkUnread, blnMultipleMove, blnNoRequests ' PDA only
Dim blnRecipientError, blnSendReadReceipts
Dim blnSenderSubjectBreak, blnShowDatesInFolder ' PDA only
Dim blnShowDatesNotSubjects ' WAP only
Dim blnShowDebugDuration
Dim blnShowTimesInFolder, blnUseJavaScript, blnUseTables, blnUseTelLinks ' PDA only

Dim intAddressesPerPage, intAppointmentsPerPage
Dim intFoldersPerPage ' WAP only
Dim intListingSenderWidth, intListingSubjectWidth, intMaxPageSize, intMessagesPerPage, intNotesPerPage
Dim intOriginalMsgLength, intPreviewSize, intShowIcons ' PDA only
Dim intTasksPerPage
Dim intTextAreaCols, intTextAreaRows ' PDA only

Dim objNameTranslate, objTimeConverter

Dim strAccount, strAccount2
Dim strBodyColour, strCurrentRowType ' PDA only
Dim strDbg, strDebugText, strDistinguishedName, strDomain, strDomainAndUserName, strExchangeVDir, strExchangeURL
Dim strFontFace, strFontSize ' PDA only
Dim strGCProtocol, strIISVersion, strLDAPConfigPath, strLDAPPath, strLDAPProtocol, strLogonUser, strPageName, strPassword, strProtocol
Dim strRefreshMins ' PDA only
Dim strServerURL
Dim strTableRowColourA, strTableRowColourB, strTextAreaSize ' PDA only
Dim strUPN, strUserName

Dim timStart

Dim objWinHTTP, objWinHTTP2, strCadata, strSessionid
Dim strDisplayName, strSMTPAddress, strPrefsMessageSubject, strStatusMessageSubject, strPrefsText, strParamsText
Dim strHomeServer, strPortNumber, strMailboxURL, strPublicURL, strBaseURL
Dim strCalendarURL, strContactsURL, strDeletedItemsURL, strDraftsURL, strInboxURL, strNotesURL, strOutboxURL, strSentItemsURL, strTasksURL
Dim serverTimeBias, blnCDOApptExists, objConvertAppointment, objConvertConfiguration

Dim firstMessage, lastMessage, numberOfMessages

Dim objStatusMessage, objPrefsMessage
Dim objSession, objMessage, objFolder, objTopPublicFolder
Dim objRenderApplication, objRenderer
Dim errorCode
Dim blnCanReadMessages, blnCanReadFolders, blnCanModifyObject, blnCanCreateInFolder

strXMLNS = "xmlns:a=""DAV:""" & _
  " xmlns:b=""urn:uuid:c2f41010-65b3-11d1-a29f-00aa00c14882/""" & _
  " xmlns:c=""xml:""" & _
  " xmlns:d=""http://schemas.microsoft.com/exchange/""" & _
  " xmlns:e=""http://schemas.microsoft.com/mapi/""" & _
  " xmlns:f=""http://schemas.microsoft.com/mapi/id/""" & _
  " xmlns:g=""http://schemas.microsoft.com/mapi/proptag/""" & _
  " xmlns:h=""urn:schemas:calendar:""" & _
  " xmlns:i=""urn:schemas:contacts:""" & _
  " xmlns:j=""urn:schemas:httpmail:""" & _
  " xmlns:k=""urn:schemas:mailheader:"""

CONST OPWCMN = 1 : CONST OPWCMR = 2 : CONST OPWCMA = 4 : CONST OPWCMF = 8 : CONST OPWCME = 16
CONST OPWMTMASK = 31
CONST OPWFRMB = 32 : CONST OPWFRFO = 64 : CONST OPWFRMR = 128 : CONST OPWFRAL = 256

CONST OPWICONSMBX = 1 : CONST OPWICONSFLL = 2 : CONST OPWICONSMSL = 4 ' PDA only

timeZones = Array(24, 19, 14, 46, 38, 7, 9, _
 29, 26, 22, 45, 4, 35, 23, 18, 32, 49, _
 33, 11, 44, 10, 5, 39, 40, 1, 43, 50, _
 15, 42, 21, 34, 47, 27, 48, 2, 41, 52, _
 37, 30, 16, 31, 51, 12, 28, 0, 13, 3, _
 6, 8, 36, 25, 20, 16385, 17)

timeZoneOffsets = Array(4, 9.5, -9, 6, -7, 2, -4, _
 -1, 3, 7, 8, 1, -5, 5.5, 10, -3, 2, _
 -4, -6, 9.5, -5, 2, -12, 12, 0, 10, 2, _
 -10, 10, 8, -5, 5, 2, 4.5, 0, 11, 0, _
 -6, -2, -11, 0, 3, -7, -3.5, 12, -8, 1, _
 1, -3, -6, 3.5, 9, 0, 12)

Function addAddressToString(inString, inDisplay, inAddress)

  Dim s, s2, s3
  s = inString : s2 = inDisplay : s3 = inAddress
  If s2 = "" Then s2 = s3
  s2 = Replace(s2, "\", "\\")
  s2 = Replace(s2, """", "\""")
  If s3 = "" Then s3 = s2
  If s <> "" Then s = s & ", "
  s = s & """" & s2 & """" & " " & "<" & s3 & ">"
  addAddressToString = s

End Function

Function base64Decode(inData)

  Dim b1, b2, b3, b4, s, i
  base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
  s = ""
  For i = 0 To Len(inData) - 1 Step 4
    b1 = InStr(base64, Mid(inData, i + 1, 1)) - 1
    b2 = InStr(base64, Mid(inData, i + 2, 1)) - 1
    b3 = InStr(base64, Mid(inData, i + 3, 1)) - 1
    b4 = InStr(base64, Mid(inData, i + 4, 1)) - 1            
    s = s & ChrB(b1 * 4 + b2 \ 16)
    If b3 >= 0 Then
        s = s & ChrB((b2 And 15) * 16 + b3 \ 4)
    Else
        s = s & ChrB((i * 3 \ 4 + 1) = (b2 And 15) * 16)
    End If
    If b4 >= 0 Then
        s = s & ChrB((b3 And 3) * 64 + b4)
    End If
  Next
  base64Decode = s

End Function

Function base64DecodeSafe(inData)

  Dim c, i, s, s2
  s = base64Decode(s) : s2 = ""
  For i = 1 To Len(s)
    c = Mid(s, i, 1)
    If Asc(c) > 0 Then
      s2 = s2 & c
    Else
      s2 = s2 & " "
    End If
  Next
  base64DecodeSafe = s2

End Function

Function base64Encode(inData)

  Dim c(100), n, c2, c3, t, t2, t3, t4, t5, t6, t7, t8
  base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
  For n = 0 To Len(base64) : c(n) = Mid(base64, n + 1, 1) : Next
  n = 1 : c2 = 0 : c3 = 0 : t6 = "" : t7 = ""
  For n = 1 To Len(inData) Step 3
    t = Mid(inData, n, 3)
    t2 = (65536 * myAsc(Left(t, 1))) + (256 * myAsc(Mid(t, 2, 1))) + myAsc(Right(t, 1))
    t3 = Oct(t2)
    t4 = Right("0000000" & t3, 8)
    t5 = c("&O" & Left(t4, 2)) & c("&O" & Mid(t4, 3, 2)) & c("&O" & Mid(t4, 5, 2)) & c("&O" & Right(t4, 2))
    t6 = t6 & t5
    c2 = c2 + 4
    If c2 >= 76 Then
      c2 = 0
      t6 = t6 & vbCrLf
      c3 = c3 + 1
      If c3 >= 10000 Then
        c3 = 0
        t7 = t7 & t6
        t6 = ""
      End If
    End If
  Next
  t8 = t7 & t6
  Select Case Len(inData) Mod 3
    Case 1:
      t8 = Left(t8, Len(t8) - 2) & "=="
    Case 2:
      t8 = Left(t8, Len(t8) - 1) & "="
  End Select
  base64Encode = t8

End Function

Sub checkInboxUnread ' PDA only

  Dim n, s, s2
  n = getUnreadCount(strInboxURL)
  If n <> 0 Then
    s = getFolderName(strInboxURL)
    oldEm0 = em0 : oldSt0 = st0 : oldFi0 = fi0 : oldMn0 = mn0 : oldVd0 = vd0
    st0 = "" : fi0 = strInboxURL : mn0 = 0
    s2 = "FI0,ST0,MN0,BOLD,NOBR"
    If em0 <> "" Then em0 = "" : s2 = s2 & ",EM0"
    If vd0 <> "" Then vd0 = "" : s2 = s2 & ",VD0"
    writeLinkWParams "MSL.asp", s, s2
    em0 = oldEm0 : st0 = oldSt0 : fi0 = oldFi0 : mn0 = oldMn0 : vd0 = oldVd0
    rwbc "<b>(" & n & ")</b>"
  End If

End Sub

Function checkNames(inString)

  Dim arrTo, blnInAD, i, objCmd, objConn, objRs
  Dim strAddress, strMembers, strOut, strTo, strStatus, strSQL, strXML
  strOut = ""
  arrTo = Split(inString, ";")
  For i = LBound(arrTo) To UBound(arrTo)
    strTo = Trim(arrTo(i))
    If strTo <> "" Then
      If Instr(strTo, "@") <> 0 Then
        strOut = addAddressToString(strOut, strTo, strTo)
      Else
        Set objConn = Server.CreateObject("ADODB.Connection")
        objConn.Provider = "ADsDSOObject"
        objConn.Properties("ADSI Flag") = 33 ' 1
        If Not CUSTOMFBA Then
          objConn.Open "ADs Provider"
        Else
          objConn.Open "ADs Provider", strLogonUser, strPassword
        End If
        Set objCmd = Server.CreateObject("ADODB.Command")
        objCmd.ActiveConnection = objConn
        strSQL = "<" & strGCProtocol & strLDAPPath & ">;(sAMAccountName=" & strTo & ");displayName,proxyAddresses"
        objCmd.CommandText = strSQL
        Set objRs = objCmd.Execute
        blnInAD = False
        If Not(objRs.BOF And objRs.EOF) Then
          strName = objRs("displayName") : strAddress = getDefaultProxyAddress(objRs("proxyAddresses"))
          blnInAD = True
        End If
        If Not blnInAD Then
          strSQL = "<" & strGCProtocol & strLDAPPath & ">;(displayName=" & strTo & ");proxyAddresses"
          objCmd.CommandText = strSQL
          Set objRs = objCmd.Execute
          If Not(objRs.BOF And objRs.EOF) Then
            If objRs.RecordCount = 1 Then
              strName = strTo : strAddress = getDefaultProxyAddress(objRs("proxyAddresses"))
            Else
              strName = strTo : strAddress = strTo
              writeTitle "* " & ERRORTEXT & COLONSPACETEXT & strTo & " - " & AMBIGUOUSTEXT & " *"
            End If
            blnInAD = True
          End If
        End If
        Set objConn = Nothing : Set objCmd = Nothing : Set objRs = Nothing
        If blnInAD Then
          strOut = addAddressToString(strOut, strName, strAddress)
        Else
          strXML = "<a:searchrequest xmlns:a=""DAV:""><a:sql>" & _
             "SELECT" & _
             " ""http://schemas.microsoft.com/mapi/dlmembers""" & _
             " FROM scope('shallow traversal of """ & strMailboxURL & strContactsURL & """')" & _
             " WHERE ""DAV:isfolder"" = False" & _
             " AND ""DAV:ishidden"" = False" & _
             " AND ""urn:schemas:httpmail:subject"" = '" & displayEncodeX0(strTo) & "'" & _
           "</a:sql></a:searchrequest>"
          strStatus = doWinHTTPSend("SEARCH", strMailboxURL & strContactsURL, strXML)
          If Left(strStatus, 1) = "2" Then
            strMembers = getXMLNode("http://schemas.microsoft.com/mapi/", "dlmembers")
            If strMembers <> "" Then
              strOut = addAddressToString(strOut, strTo, strTo)
            Else
              ' Add to recipients list anyway - just in case.
              strOut = addAddressToString(strOut, strTo, strTo)
              writeTitle "* " & ERRORTEXT & COLONSPACETEXT & strTo & " - " & NOTFOUNDTEXT & " *"
            End If ' If strMembers <> "" Then
          End If ' If Left(strStatus, 1) = "2" Then
        End If ' If b Then
      End If ' If Instr(strTo, "@") <> 0 Then
    End If ' If strTo <> "" Then
  Next ' For i = 0 To UBound(arrTo)
  checkNames = strOut

End Function

Function daysInMonth(inMonth, inYear)
  daysInMonth = Day(DateAdd("d", -1, DateSerial(inYear, inMonth + 1, 1)))
End Function

Sub debugWrite(inText)

  Dim s, t
  s = inText
  If blnShowDebugDuration Then
    t = DateDiff("s", timStart, Now)
    s = t & "s - " & s
  End If
  strDebugText = strDebugText & s & vbCrLf
  If blnDebug Then rw s & vbCrLf
  blnShowDebugDuration = False
  If Instr(UCase(s), "<BR>") <> 0 Then blnShowDebugDuration = True

End Sub

Function displayEncode0(textIn)

  ' Encode for page output
  Dim s
  s = textIn : If IsNull(s) Then s = ""
  s = myUTF8ToAsciiB(s)
  If Not ISWAP Then
    s = Replace(s, vbCrLf, BRTEXT & vbCrLf)
  Else
    ' Not doing &nbsp; to save page space.
    s = Replace(s, "'", "&apos;")
    s = Replace(s, "$", "$$")
    s = Replace(s, vbCrLf, BRTEXT & vbCrLf)
  End If
  displayEncode0 = s

End Function

Function displayEncodeI0(textIn)

  ' Encode for input fields
  Dim s
  s = textIn : If IsNull(s) Then s = ""
  s = myUTF8ToAsciiB(s)
  If ISWAP Then
    s = Replace(s, "'", "&apos;")
    s = Replace(s, "$", "$$")
  End If
  displayEncodeI0 = s

End Function

Function displayEncodeX0(textIn)

  ' Encode for XML
  Dim s
  s = textIn : If IsNull(s) Then s = ""
  s = myUTF8ToAsciiB(s)
  displayEncodeX0 = s

End Function

Sub doLogonLink

  Dim r
  Randomize : r = Int(10000000000 * Rnd)
  rw "<a href='Default.asp?reauth=" & r
  If strDbg <> "" Then rw "&dbg=" & strDbg
  rwbc "'>" & displayEncode0(LOGONTEXT) & "</a>"
  Session("lastReauth") = r

End Sub

Function doWinHTTPDelete(inURL, inDepth)

  Dim s
  objWinHTTP.Open "DELETE", inURL, False
  If inDepth <> "" Then objWinHTTP.SetRequestHeader "Depth", inDepth
  s = doWinHTTPSend2("")
  doWinHTTPDelete = s

End Function

Function doWinHTTPGet(inURL, inTranslate)

  Dim s, s2
  objWinHTTP.Open "GET", inURL, False
  If inTranslate <> "" Then objWinHTTP.SetRequestHeader "translate", inTranslate
  s = doWinHTTPSend2("")
  If s = "302" Then
    s2 = objWinHTTP.GetResponseHeader("Location")
    objWinHTTP.Open "GET", s2, False
    s = doWinHTTPSend2("")
  End If
  doWinHTTPGet = s
  If strSessionid = "" Then
    locT = objWinHTTP.GetAllResponseHeaders
    locArrT = Split(locT, vbCrLf)
    For locN = LBound(locArrT) To UBound(locArrT)
      locT2 = locArrT(locN)
      locArrT2 = Split(locT2, ":")
      If UBound(locArrT2) > 0 Then
        If UCase(locArrT2(0)) = "SET-COOKIE" Then
          locT3 = Trim(locArrT2(1))
          If Left(UCase(locT3), Len("sessionid")) = "SESSIONID" Then
            strSessionid = locT3
          End If
        End If
      End If
    Next
  End If

End Function

Function doWinHTTPSearch(inURL, inXML, inRange)

  objWinHTTP.Open "SEARCH", inURL, False
  If inRange <> "" Then
    objWinHTTP.SetRequestHeader "Range", inRange
  End If
  objWinHTTP.SetRequestHeader "content-type", "text/xml"
  objWinHTTP.SetRequestHeader "translate", "f"
  objWinHTTP.SetRequestHeader "depth", "0"
  doWinHTTPSearch = doWinHTTPSend2(inXML)

End Function

Function doWinHTTPSend(inVerb, inURL, inXML)

  Dim s, s2
  s = doWinHTTPSend1(inVerb, inURL, inXML)
  If s = "302" Then
    s2 = objWinHTTP.GetResponseHeader("Location")
    s = doWinHTTPSend1(inVerb, s2, inXML)
  End If
  doWinHTTPSend = s

End Function

Function doWinHTTPSend1(inVerb, inURL, inXML)

  objWinHTTP.Open inVerb, inURL, False
  If (inVerb = "MOVE") Or (inVerb = "COPY") Then
    objWinHTTP.SetRequestHeader "destination", inXML
    inXML = ""
  End If
  If (inXML <> "") And (inVerb <> "POST") Then
    objWinHTTP.SetRequestHeader "content-type", "text/xml"
    objWinHTTP.SetRequestHeader "translate", "f"
    objWinHTTP.SetRequestHeader "depth", "0"
  End If
  doWinHTTPSend1 = doWinHTTPSend2(inXML)
'  If strSessionid = "" Then
'    locT = objWinHTTP.GetAllResponseHeaders
'    locArrT = Split(locT, vbCrLf)
'    For locN = LBound(locArrT) To UBound(locArrT)
'      locT2 = locArrT(locN)
'      locArrT2 = Split(locT2, ":")
'      If UBound(locArrT2) > 0 Then
'        If UCase(locArrT2(0)) = "SET-COOKIE" Then
'          locT3 = Trim(locArrT2(1))
'          If Left(UCase(locT3), Len("sessionid")) = "SESSIONID" Then
'            strSessionid = locT3
'          End If
'        End If
'      End If
'    Next
'  End If

End Function

Function doWinHTTPSend2(inXML)

  objWinHTTP.SetAutoLogonPolicy 0
  If strPassword <> "" Then objWinHTTP.SetCredentials strAccount, strPassword, 0
  If strSessionid <> "" Then objWinHTTP.SetRequestHeader "cookie", strSessionid
  If strCadata <> "" Then objWinHTTP.SetRequestHeader "cookie", strCadata
'  objWinHTTP.SetRequestHeader "Connection", "Close"
  If SHOWERRORS Then On Error Resume Next
  objWinHTTP.Send inXML
  errNumber = Err.Number
  If SHOWERRORS Then On Error Goto 0
  If errNumber <> 0 Then
    rwbc "Can't connect to URL " & objWinHTTP.Option(1) ' WinHttpRequestOption_URL
    Response.End
  End If
  doWinHTTPSend2 = objWinHTTP.Status

End Function

Function doWinHTTP2Get(inURL, inTranslate)

  Dim s, s2
  objWinHTTP2.Open "GET", inURL, False
  If inTranslate <> "" Then objWinHTTP2.SetRequestHeader "translate", inTranslate
  s = doWinHTTP2Send2("")
  If s = "302" Then
    s2 = objWinHTTP2.GetResponseHeader("Location")
    objWinHTTP2.Open "GET", s2, False
    s = doWinHTTP2Send2("")
  End If
  doWinHTTP2Get = s

End Function

Function doWinHTTP2Send(inVerb, inURL, inXML)

  Dim s, s2
  s = doWinHTTP2Send1(inVerb, inURL, inXML)
  If s = "302" Then
    s2 = objWinHTTP2.GetResponseHeader("Location")
    s = doWinHTTP2Send1(inVerb, s2, inXML)
  End If
  doWinHTTP2Send = s

End Function

Function doWinHTTP2Send1(inVerb, inURL, inXML)

  objWinHTTP2.Open inVerb, inURL, False
  If inVerb = "MOVE" Then
    objWinHTTP2.SetRequestHeader "destination", inXML
    inXML = ""
  End If
  If (inXML <> "") And (inVerb <> "POST") Then
    objWinHTTP2.SetRequestHeader "content-type", "text/xml"
    objWinHTTP2.SetRequestHeader "translate", "f"
    objWinHTTP2.SetRequestHeader "depth", "0"
  End If
  doWinHTTP2Send1 = doWinHTTP2Send2(inXML)

End Function

Function doWinHTTP2Send2(inXML)

  objWinHTTP2.SetAutoLogonPolicy 0
  If strPassword <> "" Then objWinHTTP2.SetCredentials strAccount, strPassword, 0
  If strSessionid <> "" Then objWinHTTP2.SetRequestHeader "cookie", strSessionid
  If strCadata <> "" Then objWinHTTP2.SetRequestHeader "cookie", strCadata
'  objWinHTTP2.SetRequestHeader "Connection", "Close"
  objWinHTTP2.Send inXML
  doWinHTTP2Send2 = objWinHTTP2.Status

End Function

Sub dwr
  rwbc displayEncode0(objWinHTTP.ResponseText)
End Sub

Sub getAccess(inObject)

  strXML = "<a:propfind " & strXMLNS & "><a:prop>" & _
     "<a:isfolder/>" & _
     "<a:parentname/>" & _
     "<g:0x0FF40003/>" & _
   "</a:prop></a:propfind>"
  strStatus = doWinHTTPSend("PROPFIND", inObject, strXML)
  If Left(strStatus, 1) = "2" Then
    locLngObjectACL = getXMLNode("http://schemas.microsoft.com/mapi/proptag/", "0x0FF40003")
    isFolder = (getXMLNode("DAV:", "isfolder") = 1)
    If isFolder Then
      blnCanModifyObject = (locLngObjectACL And &H00000001) <> 0 ' MAPI_ACCESS_MODIFY
      blnCanReadMessages = True ' WebDAV searchrequest will take care of this
      blnCanReadFolders = True ' -//-
      blnCanCreateInFolder = (locLngObjectACL And &H00000010) <> 0 ' MAPI_ACCESS_CREATE_CONTENTS
    Else
      locParentname = getXMLNode("DAV:", "parentname")
      strXML = "<a:propfind " & strXMLNS & "><a:prop><g:0x0FF40003/></a:prop></a:propfind>"
      If Left(doWinHTTPSend("PROPFIND", locParentname, strXML), 1) = "2" Then
        locLngObjectACL = getXMLNode("http://schemas.microsoft.com/mapi/proptag/", "0x0FF40003")
        ' DAV always returns 2 for non-folder items, so assume that item will inherit permissions from folder
        blnCanModifyObject = (locLngObjectACL And &H00000001) <> 0 ' MAPI_ACCESS_MODIFY
        blnCanCreateInFolder = (locLngObjectACL And &H00000010) <> 0 ' MAPI_ACCESS_CREATE_CONTENTS
      End If
    End If
  Else
    rwbc "Can't locate item"
    Response.End
  End If

  If blnDebug Then
    If isFolder Then
      rwbc "Can read messages: " & blnCanReadMessages
      rwbc "Can read folders: " & blnCanReadFolders
    End If
    rwbc "Can modify: " & blnCanModifyObject
    rwbc "Can create in folder: " & blnCanCreateInFolder
  End If

End Sub

Function getAddresses(inString)

  Dim a(), c, n, p, p2, p3, s, s2, s3, s4
  ReDim Preserve a(1, -1)
  s = Trim(inString) : n = 0 : p = 1 : p2 = 1
  If s <> "" Then
    Do While p < Len(s)
      c = Mid(s, p, 1)
      Do While c = " "
        p = p + 1
        c = Mid(s, p, 1)
      Loop
      If c = """" Then
        p2 = Instr(p + 1, s, """")
        s2 = Mid(s, p + 1, (p2 - 1) - p)
        p = Instr(p2, s, "<")
        p2 = Instr(p + 1, s, ">")
        s3 = Mid(s, p + 1, (p2 - 1) - p)
        p = Instr(p2 + 1, s, ",")
        If p = 0 Then p = Len(s)
      ElseIf c = "<" Then
        p2 = Instr(p + 1, s, ">")
        s2 = Mid(s, p + 1, (p2 - 1) - p)
        s3 = s2
        p = Instr(p2 + 1, s, ",")
        If p = 0 Then p = Len(s)
      Else
        p2 = Instr(p + 1, s, ",")
        If p2 = 0 Then p2 = Len(s) + 1
        s2 = Mid(s, p, p2 - p)
        p3 = Instr(s2, "<")
        If p3 = 0 Then
          s3 = s2
        Else
          s4 = s2
          s2 = Trim(Left(s4, p3 - 1))
          s3 = Mid(s4, p3 + 1, (Len(s4) - p3) - 1)
        End If
        p = p2
      End If
      s2 = Replace(s2, "\\", "\")
      s2 = Replace(s2, "\""", """")
      n = n + 1
      ReDim Preserve a(1, n - 1)
      a(0, n - 1) = s2
      a(1, n - 1) = s3
      p = p + 1
    Loop
  End If
  getAddresses = a

End Function

Function getDateTimeFromTZ(inDateTimeTZ)

  Dim arrS, arrS2, arrS3, d, dt, dt2, s, t
  s = inDateTimeTZ
  If s <> "" Then
    If (Mid(s, Len(s) - 4, 1) = ".") And (Right(s, 1) = "Z") Then
      s = Left(s, Len(s) - 5)
      arrS = Split(s, "T")
      If UBound(arrS) = 1 Then
        arrS2 = Split(arrS(0), "-")
        d = DateSerial(arrS2(0), arrS2(1), arrS2(2))
        arrS3 = Split(arrS(1), ":")
        t = TimeSerial(arrS3(0), arrS3(1), arrS3(2))
        dt = d + t
        dt2 = getLocalDateTime(dt)
      End If
    End If
  End If
  If dt2 <> "" Then
    getDateTimeFromTZ = dt2
  Else
    rwbc "getDateTimeFromTZ error - inDateTimeTZ=" & inDateTimeTZ : Response.End
  End If

End Function

Function getDefaultProxyAddress(inArray)

  Dim arrT, i, s, s2, s3
  If IsArray(inArray) Then
    arrT = inArray : s = ""
    For i = LBound(arrT) To UBound(arrT)
      s2 = arrT(i)
      If Left(UCase(s2), 5) = "SMTP:" Then
        s3 = Right(s2, Len(s2) - Len("SMTP:"))
        If s = "" Then s = s3
        If Left((s2), 5) = "SMTP:" Then s = s3
      End If
    Next
  Else
    s = inArray
  End If
  If Instr(s, "@") = 0 Then rwbc "Invalid proxyAddress '" & s & "'" : Response.End
  getDefaultProxyAddress = s

End Function

Function getFolderName(inFolderID)

  Dim s
  strXML = "<a:propfind " & strXMLNS & "><a:prop><a:displayname/></a:prop></a:propfind>"
  strStatus = doWinHTTPSend("PROPFIND", strMailboxURL & inFolderID, strXML)
  If Left(strStatus, 1) = "2" Then s = getXMLNode("DAV:", "displayname")
  getFolderName = s

End Function

Function getFormData(inParam)

  Dim s, v
  v = Request.Form(inParam)
  s = ""
  For n = 1 To Len(v)
    s = s & ChrB(Asc(Mid(v, n, 1))) & ChrB(0)
  Next
  getFormData = s

End Function

Function getGMTDateTime(inDateTime)

  If blnCDOApptExists Then
    objConvertConfiguration.Fields("urn:schemas:calendar:timezoneid") = tz1
    objConvertConfiguration.Fields.Update
    objConvertAppointment.StartTime = inDateTime
    objConvertConfiguration.Fields("urn:schemas:calendar:timezoneid") = 0
    objConvertConfiguration.Fields.Update
    getGMTDateTime = objConvertAppointment.StartTime
  Else
    Dim d, t
    d = getLocalDateTime(inDateTime)
    t = d - inDateTime
    getGMTDateTime = inDateTime - t
  End If

End Function

Function getLocalDateTime(inDateTime)

  If blnCDOApptExists Then
    objConvertConfiguration.Fields("urn:schemas:calendar:timezoneid") = 0
    objConvertConfiguration.Fields.Update
    objConvertAppointment.StartTime = inDateTime
    objConvertConfiguration.Fields("urn:schemas:calendar:timezoneid") = tz1
    objConvertConfiguration.Fields.Update
    getLocalDateTime = objConvertAppointment.StartTime
  Else
    Dim d, dy, hr, mi, mo, p, p2, p3, s, s2, s3, se, t, x, yr
    d = getTZFromDateTime(inDateTime)
    x = "<a:propertyupdate " & strXMLNS & "><a:set><a:prop>" & _
       "<h:dtend>" & d & "</h:dtend>" & _
       "<h:dtstart>" & d & "</h:dtstart>" & _
       "<h:timezoneid>" & tz1 & "</h:timezoneid>" & _
     "</a:prop></a:set></a:propertyupdate>"
    doWinHTTP2Send "PROPPATCH", strMailboxURL & strCalendarURL & "OWA FOR PDA AND WAP TIME CONVERTER.EML", x
    'rwbc displayEncode0(objWinHTTP2.ResponseText)
    doWinHTTP2GET strMailboxURL & strCalendarURL & "OWA FOR PDA AND WAP TIME CONVERTER.EML", "f"
    'rwbc displayEncode0(objWinHTTP2.ResponseText)
    s = objWinHTTP2.ResponseText
    p = Instr(UCase(s), "DTSTART;TZID")
    If p <> 0 Then
      p2 = Instr(p + 1, s, vbCrLf) : p2 = Instr(p2 + 1, s, vbCrLf)
      s2 = Mid(s, p, p2 - p) : s2 = Replace(s2, vbCrLf, "") : s2 = Replace(s2, " ", "")
      p3 = InstrRev(s2, ":")
      If p3 <> 0 Then s3 = Mid(s2, P3 + 1, 15)
    End If
    If (Len(s3) = 15) And Mid(s3, 9, 1) = "T" Then
      dy = Mid(s3, 7, 2) : mo = Mid(s3, 5, 2) : yr = Left(s3, 4)
      hr = Mid(s3, 10, 2) : mi = Mid(s3, 12, 2) : se = Right(s3, 2)
      getLocalDateTime = DateSerial(yr, mo, dy) + TimeSerial(hr, mi, se)
    Else
      rwbc "getLocalDateTime error" : Response.End
    End If
  End If

End Function

Function getLocalTime

  Dim t
  strXML = "<a:propertyupdate " & strXMLNS & "><a:set><a:prop>" & _
     "<j:textdescription></j:textdescription>" & _
   "</a:prop></a:set></a:propertyupdate>"
  strStatus = doWinHTTPSend("PROPPATCH", strMailboxURL & strCalendarURL & "OWA FOR PDA AND WAP TIME CONVERTER.EML", strXML)
  If Left(strStatus, 1) = "2" Then
    strXML = "<a:propfind xmlns:a=""DAV:""><a:prop>" & _
       "<a:getlastmodified/>" & _
     "</a:prop></a:propfind>"
    strStatus = doWinHTTPSend("PROPFIND", strMailboxURL & strCalendarURL & "OWA FOR PDA AND WAP TIME CONVERTER.EML", strXML)
    If Left(strStatus, 1) = "2" Then
      strLastmodified = getXMLNode("DAV:", "getlastmodified")
      t = getDateTimeFromTZ(strLastmodified)
    End If
  End If
  getLocalTime = t

End Function

Function getNextFreeURL(inStore, inContainer, inDisplay, inExtension)

  Dim r, s, s2
  s = inDisplay
  If s = "" Then s = "NoSubject"
  s = Server.URLEncode(displayEncodeX0(s))
  Randomize
  r = Int(100000 * Rnd)
  s2 = s & "-" & Year(Now) & Month(Now) & Day(Now) & Hour(Now) & Minute(Now) & Second(Now) & "-" & r & inExtension
  getNextFreeURL = s2

End Function

Function getOOFState

  locT = "N"
  locXML = "<a:propfind " & strXMLNS & "><a:prop><d:oof-state/></a:prop></a:propfind>"
  If Left(doWinHTTPSend("PROPFIND", strMailboxURL & "NON_IPM_SUBTREE/", locXML), 1) = "2" Then
    If getXMLNode("http://schemas.microsoft.com/exchange/", "oof-state") = 1 Then locT = "Y"
  End If
  getOOFState = locT

End Function

Function getParam(inParam, inSave)

  If Not blnNoRequests Then
    locT = Request.QueryString(inParam)
    If (locT = "") And (Request.QueryString(inParam).Count = 0) Then
      If Request.Form(inParam).Count = 1 Then
        locT = getFormData(inParam)
      Else
        locT = Request.Form(inParam)
      End If
      If (locT = "") And (Request.Form(inParam).Count = 0) Then
        locT2 = strParamsText
        locStrStart = "#OPW" & inParam & "#"
        locStrEnd = "#END" & inParam & "#"
        locP = Instr(locT2, locStrStart)
        If locP <> 0 Then
          locP2 = Instr(locP, locT2, locStrEnd)
          locT3 = Mid(locT2, locP, locP2 - locP)
          locT = Replace(locT3, locStrStart, "")
        End If
      End if
    End If
    If inSave Then setParam inParam, locT
    getParam = locT
  End If

End Function

Sub setParam(inParam, inValue)

  Dim v
  v = inValue
  locStrStart = "#OPW" & inParam & "#"
  locStrEnd = "#END" & inParam & "#"
  locP = Instr(strParamsText, locStrStart)
  Do While locP <> 0
    locP2 = Instr(strParamsText, locStrEnd) + Len(locStrEnd)
    locT = Mid(strParamsText, locP, locP2 - locP)
    strParamsText = Replace(strParamsText, locT, "")
    locP = Instr(strParamsText, locStrStart)
  Loop
  locStrValue = locStrStart & v & locStrEnd
  strParamsText = strParamsText & locStrValue

End Sub

Sub getParams

  Dim n
  If blnDebug Then rwbc "User Status:" : rwbc displayEncode0(strParamsText)
  ac0 = getParam("ac0", False)
  If Not ISWAP Then
    If Not blnNoRequests Then
      ' PocketIE doesn't like multiple submit controls with the same name,
      '  so we have ac1, ac2, ... etc.
      n = 0
      Do While (ac0 = "") And (n <= 5)
        n = n + 1
        ac0 = Request.Form("ac" & n)
      Loop
    End If
  End If

  at0 = getParam("at0", True)
  ci0 = getParam("ci0", True) : ci0 = recoverID(ci0)

  If Not ISWAP Then
    dy0 = getParam("dy0", True) : If dy0 = "" Then dy0 = CStr(Day(Date))
    mo0 = getParam("mo0", True) : If mo0 = "" Then mo0 = CStr(Month(Date))
    yr0 = getParam("yr0", True) : If yr0 = "" Then yr0 = CStr(Year(Date))
  Else
    dt0 = getParam("dt0", True)
    If dt0 = "" Then
      dy0 = Day(Date) : mo0 = Month(Date) : yr0 = Year(Date)
      dt0 = mo0 & "/" & dy0 & "/" & yr0
    End If
    arrDate = Split(dt0, "/")
    If UBound(arrDate) = 2 Then
      mo0 = arrDate(0) : dy0 = arrDate(1) : yr0 = arrDate(2)
    End If
  End If

  fi0 = getParam("fi0", True) : fi0 = recoverID(fi0)
  If IsNumeric(fi0) Then fi0 = CInt(fi0)
  If fi0 = "OPWINBOX" Then
    fi0 = strInboxURL
  End If

  lastFi0 = getParam("lastFi0", True)
  If IsNumeric(lastFi0) Then lastFi0 = CInt(lastFi0)

  fl0 = getParam("fl0", True)
  If Not ISWAP Then fl1 = getParam("fl1", True)
  fl2 = getParam("fl2", True)
  fl3 = getParam("fl3", True)

  If Not ISWAP Then
    em0 = getParam("em0", True)
  Else
    fn0 = getParam("fn0", True)
    If IsNumeric(fn0) Then fn0 = CInt(fn0)
    If fn0 = "" Then fn0 = 0
    fn1 = getParam("fn1", False) : If IsNumeric(fn1) Then fn1 = Int(fn1)
  End If

  mi0 = getParam("mi0", True) : mi0 = recoverID(mi0)
  mn0 = getParam("mn0", True)

  lastFl0 = getParam("lastFl0", False)
  lastFl1 = getParam("lastFl1", False)
  lastAl0 = getParam("lastAl0", False)
  If (fl0 <> lastFl0) Or (fl1 <> lastFl1) Or (al0 <> lastAl0) Then
    mn0 = 0
    setParam "mn0", mn0
    lastFl0 = fl0
    setParam "lastFl0", lastFl0
    lastFl1 = fl1
    setParam "lastFl1", lastFl1
    lastAl0 = al0
    setParam "lastAl0", lastAl0
  End If

  mt0 = getParam("mt0", True) : If IsNumeric(mt0) Then mt0 = CInt(mt0)
  pg0 = getParam("pg0", False)
  pg1 = getParam("pg1", False) : If pg1 = 0 Then pg1 = 1
  rs0 = getParam("rs0", True)
  ry0 = getParam("ry0", True) : If IsNumeric(ry0) Then ry0 = Int(ry0)
  st0 = getParam("st0", True)
  vd0 = getParam("vd0", True)

  If fi0 <> lastFi0 Then
    If ISWAP Then fn0 = 0 : setParam "fn0", fn0
    mn0 = 0 : setParam "mn0", mn0
    fl3 = "" : setParam "fl3", fl3
    fl2 = "" : setParam "fl2", fl2
    lastFi0 = fi0 : setParam "lastFi0", lastFi0
  End If

  If IsNumeric(mn0) Then mn0 = CInt(mn0)
  If mn0 = "" Then mn0 = 0

End Sub

Function getPref(inPref, inSave)

  If Not blnNoRequests Then
    locT = Request.QueryString(inPref)
    If (locT = "") And (Request.QueryString(inPref).Count = 0) Then
      locT = Request.Form(inPref)
      If (locT = "") And (Request.Form(inPref).Count = 0) Then
        locT2 = strPrefsText
        locStrStart = "#OPW" & inPref & "#"
        locStrEnd = "#END" & inPref & "#"
        locP = Instr(locT2, locStrStart)
        If locP <> 0 Then
          locP2 = Instr(locP, locT2, locStrEnd)
          locT3 = Mid(locT2, locP, locP2 - locP)
          locT = Replace(locT3, locStrStart, "")
        End If
      End If
    End If
    If inSave Then setPref inPref, locT
    getPref = locT
  End If

End Function

Sub setPref(inPref, inValue)

  locStrStart = "#OPW" & inPref & "#"
  locStrEnd = "#END" & inPref & "#"
  locP = Instr(strPrefsText, locStrStart)
  Do While locP <> 0
    locP2 = Instr(strPrefsText, locStrEnd) + Len(locStrEnd)
    locT = Mid(strPrefsText, locP, locP2 - locP)
    strPrefsText = Replace(strPrefsText, locT, "")
    locP = Instr(strPrefsText, locStrStart)
  Loop
  locStrValue = locStrStart & inValue & locStrEnd
  strPrefsText = strPrefsText & locStrValue

End Sub

Sub getPrefs

  Dim arrItemsPerPage, blnResetAl0, lastAPI, lastMailboxURL, n, s, strItemsPerPage, t
  If blnDebug Then rwbc "User Prefs:" : rwbc displayEncode0(strPrefsText)
  blnResetAl0 = False
  lastAPI = getPref("lastAPI", False)
  If lastAPI <> API Then
    setPref "lastAPI", API
    blnResetAl0 = True
  End If
  lastMailboxURL = getPref("lastMailboxURL", False)
  If lastMailboxURL <> strMailboxURL Then
    setPref "lastMailboxURL", strMailboxURL
    blnResetAl0 = True
  End If
  al0 = getPref("al0", True)
  If al0 = "" Then blnResetAl0 = True
  If blnResetAl0 Then
    al0 = strMailboxURL & strContactsURL
    setPref "al0", al0
  End If
  mr0 = getPref("mr0", False)
  blnMarkAsRead = mr0 <> "N"
  sr0 = getPref("sr0", False)
  blnSendReadReceipts = sr0 <> "N"

  If Not ISWAP Then
    ef0 = getPref("ef0", False)
    blnExpandFolders = ef0 = "Y"
    ef1 = getPref("ef1", False)
    blnExpandPublicFolders = ef1 = "Y"
    sd0 = getPref("sd0", False)
    blnShowDatesInFolder = sd0 = "Y"
    st1 = getPref("st1", False)
    blnShowTimesInFolder = st1 = "Y"
  End If

  intListingSenderWidth = 9
  fw0 = Trim(getPref("fw0", False))
  If IsNumeric(fw0) Then intListingSenderWidth = CInt(fw0)
  intListingSubjectWidth = DEFSUBJECTWIDTH
  fw1 = Trim(getPref("fw1", False))
  If IsNumeric(fw1) Then intListingSubjectWidth = CInt(fw1)
  strItemsPerPage = Trim(getPref("ip0", False))
  arrItemsPerPage = Split(strItemsPerPage, ",")
  intAddressesPerPage = getPrefs2(arrItemsPerPage, 0, DEFADDRSPERPAGE)
  intAppointmentsPerPage = getPrefs2(arrItemsPerPage, 1, DEFAPPTSPERPAGE)
  intMessagesPerPage = getPrefs2(arrItemsPerPage, 2, DEFMSGSPERPAGE)
  intNotesPerPage = getPrefs2(arrItemsPerPage, 3, DEFNOTESPERPAGE)
  intTasksPerPage = getPrefs2(arrItemsPerPage, 4, DEFTASKSPERPAGE)
  If ISWAP Then
    intFoldersPerPage = getPrefs2(arrItemsPerPage, 5, 4)
    sd1 = getPref("sd1", False)
    blnShowDatesNotSubjects = sd1 = "Y"
  End If
  If Not ISWAP Then
    strFontFace = Trim(getPref("ff0", False))
    strFontSize = Trim(getPref("fs0", False))
    If ALLOWINBOXREFRESH Then strRefreshMins = getPref("rm0", False)
    If ICONCONTROL = "" Then
      intShowIcons = getPref("si2", False)
      If intShowIcons = "" Then intShowIcons = OPWICONSMBX + OPWICONSFLL + OPWICONSMSL
    Else
      intShowIcons = CInt(ICONCONTROL)
    End If
    intPreviewSize = getPref("ps0", False)
    If intPreviewSize = "" Then intPreviewSize = 0
    ut0 = getPref("ut0", False)
    blnUseTables = ut0 <> "N"
    ut1 = getPref("ut1", False)
    blnUseTelLinks = ut1 = "Y"
  End If
  intMaxPageSize = getPref("ps1", False)
  If intMaxPageSize = "" Then intMaxPageSize = DEFMAXPAGESIZE
  If Not ISWAP Then
    intTextAreaCols = getPref("ta0", False)
    If intTextAreaCols = "" Then intTextAreaCols = 20
    intTextAreaRows = getPref("ta1", False)
    If intTextAreaRows = "" Then intTextAreaRows = 10
    strTextAreaSize = "cols='" & intTextAreaCols & "' rows='" & intTextAreaRows & "'"
    intOriginalMsgLength = getPref("om0", False)
    If isNumeric(intOriginalMsgLength) Then
      If intOriginalMsgLength = "" Then intOriginalMsgLength = 1000
      intOriginalMsgLength = CInt(intOriginalMsgLength)
    Else
      intOriginalMsgLength = 1000
    End If
    ss0 = getPref("ss0", False)
    blnSenderSubjectBreak = ss0 = "Y"
    mm1 = getPref("mm1", False)
    blnMultipleMove = mm1 = "Y"
    mm2 = getPref("mm2", False)
    blnMultipleMarkUnread = mm2 = "Y"
    uj0 = getPref("uj0", False)
    blnUseJavaScript = uj0 = "Y"
  End If

End Sub

Function getPrefs2(inArray, inIndex, inDefault)

  Dim t, v
  t = ""
  If UBound(inArray) >= inIndex Then t = Trim(inArray(inIndex))
  If isNumeric(t) Then
    v = CInt(t)
  Else
    v = inDefault
  End If
  getPrefs2 = v

End Function

Function getRegistryValue(inKey)
  Dim objSh
  Set objSh = Server.CreateObject("WScript.Shell")
  getRegistryValue = objSh.RegRead(inKey)
  Set objSh = Nothing
End Function

Function getSig

  Dim s
  s = DEFAULTSIG
  s = Replace(s, "%10", vbCr)
  s = Replace(s, "%13", vbLf)
  If Left(s, 2) = "%!" Then
    s2 = Right(s, Len(s) - 2)
  Else
    s2 = getPref("si1", False)
    If Left(s, 2) = "%+" Then
      If s2 <> "" Then s2 = s2 & vbCrLf & vbCrLf
      s2 = s2 & Right(s, Len(s) - 2)
    Else
      If s2 = "" Then s2 = s
    End If
  End If
  getSig = s2

End Function

Function getTZFromDateTime(inDateTime)

  locDateTime = Year(inDateTime) & "-" & Right("0" & Month(inDateTime), 2) & "-" & Right("0" & Day(inDateTime), 2) & "T" & _
   Right("0" & Hour(inDateTime), 2) & ":" & Right("0" & Minute(inDateTime), 2) & ":" & Right("0" & Second(inDateTime), 2) & ".000Z"
  getTZFromDateTime = locDateTime

End Function

Function getTZFromLocalDateTime(inDateTime)

  d = getGMTDateTime(inDateTime)
  d2 = getTZFromDateTime(d)
  getTZFromLocalDateTime = d2

End Function

Function getUnreadCount(inFolderID)

  locXML = "<a:propfind " & strXMLNS & "><a:prop><j:unreadcount/></a:prop></a:propfind>"
  If Left(doWinHTTPSend("PROPFIND", strMailboxURL & inFolderID, locXML), 1) = "2" Then
    locT = getXMLNode("urn:schemas:httpmail:", "unreadcount")
  End If
  getUnreadCount = locT

End Function

Function getXMLNode(inNamespace, inNodename)

  Dim locT, locText, locPrefix, locNodename, locP, locP2
  locText = objWinHTTP.ResponseText
  locPrefix = getXMLPrefix(inNamespace) : locNodename = locPrefix & inNodename
  locP = Instr(locText, "<" & locNodename)
  If locP <> 0 Then
    If Mid(locText, locP + Len(locNodename) + 1, 2) = "/>" Then
      ' Do Nothing
    Else
      locP = Instr(locP + 1, locText, ">") + 1
      locP2 = Instr(locP, locText, "</" & locNodename & ">")
        If locP2 <> 0 Then
        locT = Mid(locText, locP, locP2 - locP)
        locT = Replace(locT, "&lt;", "<") : locT = Replace(locT, "&gt;", ">") : locT = Replace(locT, "&amp;", "&")
      End If
    End If
  End If
  getXMLNode = locT

End Function

Function getXMLNodes(inNamespace, inNodename)

  Dim locArrT(), locText, locPrefix, locNodename, numNodes, locP, locT, locP2
  locText = objWinHTTP.ResponseText
  locPrefix = getXMLPrefix(inNamespace) : locNodename = locPrefix & inNodename
  numNodes = 0 : locP = 1
  Do While locP <> 0
    locP = Instr(locP, locText, "<" & locNodename)
    If locP <> 0 Then
      locT = Empty
      If Mid(locText, locP + Len(locNodename) + 1, 2) = "/>" Then
        locP = Instr(locP + 1, locText, ">") + 1
      Else
        locP = Instr(locP + 1, locText, ">") + 1
        locP2 = Instr(locP, locText, "</" & locNodename & ">")
        If locP2 <> 0 Then
          locT = Mid(locText, locP, locP2 - locP)
          locT = Replace(locT, "&lt;", "<") : locT = Replace(locT, "&gt;", ">") : locT = Replace(locT, "&amp;", "&")
        End If
      End If
      numNodes = numNodes + 1 : ReDim Preserve locArrT(numNodes - 1)
      locArrT(numNodes - 1) = locT
    End If
  Loop
  getXMLNodes = locArrT

End Function

Function getXMLPrefix(inNamespace)

  Dim locText, locP, locT, locP2
  locText = objWinHTTP.ResponseText
  locP = 1
  Do While locT = ""
    locP = Instr(locP, UCase(locText), "XMLNS:")
    If locP = 0 Then Exit Do
    locP2 = Instr(locP + 9, locText, """")
    locT2 = Mid(locText, locP + 9, locP2 - (locP + 9))
    If UCase(locT2) = UCase(inNamespace) Then
      locT = Mid(locText, locP + 6, 1) & ":"
    Else
      locP = locP2
    End If
  Loop
  getXMLPrefix = locT

End Function

Sub logEvent(inSeverity, inText)

  Dim objSh
  On Error Resume Next
  Set objSh = Server.CreateObject("WScript.Shell")
  objSh.LogEvent inSeverity, inText
  Set objSh = Nothing
  On Error Goto 0

End Sub

Sub login

  Dim p, s, s2, s3, s4, objDelMsg
  timStart = Now
  If Not blnNoRequests Then strDbg = Request.QueryString("dbg") : If strDbg = "" Then strDbg = Request.Form("dbg")
  blnDebug = False : If strDbg <> "" Then blnDebug = True
  debugWrite "Debug output (requested level=" & strDbg & ") :" & BRTEXT
  debugWrite APPNAME & " " & VERSION & BRTEXT
  debugWrite Now & BRTEXT
  strIISVersion = Request.ServerVariables("SERVER_SOFTWARE")
  debugWrite strIISVersion & BRTEXT
  debugWrite Request.ServerVariables("LOCAL_ADDR") & " -> " & Request.ServerVariables("REMOTE_ADDR") & BRTEXT
  strPageName = Request.ServerVariables("URL")
  p = InstrRev(strPageName, "/")
  If p <> 0 Then strPageName = Right(strPageName, Len(strPageName) - p)
  debugWrite strPageName & BRTEXT
  If Not blnNoRequests Then
    If mb0 = "" Then mb0 = Request.QueryString("mb0") : If mb0 = "" Then mb0 = Request.Form("mb0")
    If si0 = "" Then si0 = Request.QueryString("si0") : If si0 = "" Then si0 = Request.Form("si0")
  End If
  If SHOWERRORS Then On Error Resume Next
  If SHOWERRORS Then On Error Goto 0
  mb0 = Trim(mb0)

  login2

  If errorCode = 0 Then

    ' Do we need to delete a message?
    md0 = Request.QueryString("md0")
    If (md0 = "Y") Or (md0 = "C") Then
      ' Is it a normal message?
      If md0 = "Y" Then
        s = mi0
        mi0 = ""
        setParam "mi0", mi0
      ' Is it a new composed message?
      ElseIf md0 = "C" Then
        s = ci0
        ci0 = ""
        setParam "ci0", ci0
      End If
      If s <> "" Then
        If (Left(fi0, Len(strDeletedItemsURL)) <> strDeletedItemsURL) And (md0 <> "C") And (st0 <> "u") Then
          s2 = getNextFreeURL(st0, strDeletedItemsURL, "Deleted", ".EML")
          doWinHTTPSend "MOVE", strBaseURL & s, strBaseURL & strDeletedItemsURL & s2
        Else
          doWinHTTPSend "DELETE", strBaseURL & s, ""
        End If
      End If
    End If

  End If

  If (errorCode = 1) And Not(blnDebug) And SHOWDEBUGONFAIL Then rw strDebugText

End Sub

Sub login2

  strExchangeVDir = "" : If USEEXCHANGEVDIR Then strExchangeVDir = "Exchange/"
  If CUSTOMFBA And CUSTOMFBASSL And (UCase(Request.ServerVariables("HTTPS")) <> "ON") Then
    rwbc "Application requires HTTPS when using CUSTOMFBA = True"
    writePageEnd
    Response.End
  End If
  debugWrite "CUSTOMFBA = " & CUSTOMFBA & BRTEXT
  loginGetLDAPPaths
  If login3(1) Then
    loginGetCredentials
    If login3(2) Then
      If CUSTOMFBA Then loginCheckCredentials
      If login3(3) Then
        loginGetObjects
        If login3(4) Then
          loginGetAccount
          If login3(5) Then
            loginCheckHTTP
            If login3(6) Then
              loginGetProtocol
              strServerURL = strProtocol & "://" & strHomeServer & strPortNumber & "/"
              strExchangeURL = strServerURL & strExchangeVDir
              If login3(7) Then
                loginCheckAccess
                If login3(8) Then
                  loginGetMbFolder
                  If login3(9) Then
                    loginGetMailboxParams
                    If login3(10) Then
                      'serverTimeBias = getRegistryValue("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\TimeZoneInformation\ActiveTimeBias")
                      'If login3(11) Then
                      '  loginGetPrefsMessage
                      '  If login3(12) Then
                      '    loginGetCDOTimeZone
                      '    If login3(13) Then
                      '      loginGetTimeConverter
                      '      If login3(14) Then
                      '        loginGetStatusMessage
                      '        If login3(15) Then
                      '          getPrefs
                      '          getParams
                      '          If em0 = "" Then
                                  strBaseURL = strMailboxURL : If st0 = "u" Then strBaseURL = strPublicURL
                      '          Else
                      '            p = InstrRev(strMailboxURL, "/", Len(strMailboxURL) - 1)
                      '            If p <> 0 Then s = Left(strMailboxURL, p)
                      '             strBaseURL = s & em0 & "/"
                      '          End If
                      '        End If
                      '      End If
                      '    End If
                      '  End If
                      'End If
                    End If
                  End If
                End If
              End If
            End If
          End If
        End If
      End If
    End If
  End If

End Sub

Function login3(inLevel)

 Dim b
 b = True
 If strDbg = CStr(inLevel) Then errorCode = 1
 If errorCode <> 0 Then b = False
 login3 = b

End Function

Sub loginCheckAccess

  Dim blnAccessOK, s
  debugWrite "Checking Access to Exchange Virtual Directory" & BRTEXT
  strStatus = doWinHTTPGet(strExchangeURL, "f")
  debugWrite "GET " & strExchangeURL & " (" & strStatus & ")" & BRTEXT
  blnAccessOK = False
  If strStatus = "401" Then
    debugWrite "Access Denied to DOMAIN\USER format, trying UPN" & BRTEXT
    s = strAccount
    strAccount = strAccount2
    strStatus = doWinHTTPGet(strExchangeURL, "f")
    debugWrite "GET " & strExchangeURL & " (" & strStatus & ")" & BRTEXT
    If strStatus <> "401" Then
      blnAccessOK = True
    Else
      debugWrite "Access Denied to UPN format, reverting to DOMAIN\USER for future operations" & BRTEXT
      strAccount = s
    End If
  Else
    blnAccessOK = True
  End If
  debugWrite ">> " & blnAccessOK & BRTEXT
  'If Not blnAccessOK Then errorCode = 1

End Sub

Sub loginCheckCredentials

  Dim dso, n, o, wo, wo2
  debugWrite "Checking credentials" & BRTEXT
  If SHOWERRORS Then On Error Resume Next
  Set dso = GetObject("LDAP:")
'  Set o = dso.OpenDSObject(strGCProtocol & strDistinguishedName, strDomainAndUserName, strPassword, &H220) ' ADS_SECURE_AUTHENTICATION + ADS_FAST_BIND
  Set o = dso.OpenDSObject(strLDAPProtocol & strLDAPPath, strDomainAndUserName, strPassword, &H220) ' ADS_SECURE_AUTHENTICATION + ADS_FAST_BIND
  errNumber = Err.Number
  errNumberHex = Hex(CSng(errNumber))
  errDescription = Err.Description
  If SHOWERRORS Then On Error Goto 0
  Set o = Nothing : Set dso = Nothing
  If errNumber <> 0 Then
    debugWrite "OpenDSObject " & ERRORTEXT & " " & _
     errNumberHex & " (" & errNumber & ") " & errDescription & BRTEXT
    rwbc displayEncode0(INVALIDLOGONTEXT)
    Session("OPWLOGON") = ""
    doLogonLink
    errorCode = 2
    If SHOWERRORS Then On Error Resume Next
    Set wo = GetObject("WinNT://" & strDomain & "/" & strUserName & ",user")
    If SHOWERRORS Then On Error Goto 0
    If IsObject(wo) Then
      n = wo.Get("UserFlags")
      If (n And &H800000) <> 0 Then ' ADS_UF_PASSWORD_EXPIRED
        rwbc displayEncode0(PASSWORDEXPIREDTEXT)
        Session("OPWPWE") = "Y"
        If (Not ISWAP) And PASSWORDACCESS Then writeLinkWParams "PWE2.asp", CHANGEPASSWORDTEXT, ""
      End If
      Set wo = Nothing
    'Else
    '  If SHOWERRORS Then On Error Resume Next
    '  Set wo2 = GetObject("WinNT:")
    '  If IsObject(wo2) Then
    '    Set wo = wo2.OpenDSObject("WinNT://" & strDomain & "/" & strUserName & ",user", strUserName, strPassword, 1)
    '    errNumber = Err.Number
    '    Select Case Hex(errNumber)
    '      Case "8007052E"
    '        rwbc displayEncode0("Bad username or password")
    '      Case "80070553"
    '        rwbc displayEncode0("Your account is disabled")
    '      Case "80070773"
    '        rwbc displayEncode0("Your password has expired")
    '        Session("OPWPWE") = "Y"
    '        If (Not ISWAP) And PASSWORDACCESS Then writeLinkWParams "PWE2.asp", CHANGEPASSWORDTEXT, ""
    '      Case "80070775"
    '        rwbc displayEncode0("Your account is locked")
    '    End Select
    '    If IsObject(wo) Then Set wo = Nothing
    '    Set wo2 = Nothing
    '  End If
    '  If SHOWERRORS Then On Error Goto 0
    End If
  End If

End Sub

Sub loginCheckHTTP

  Dim arrProtocolSettings, dso, i, objCmd, objConn, objRs, objUser, p, s, v

  debugWrite "Getting AD Record for " & mb0 & BRTEXT
  If Not(objNameTranslate Is Nothing) Then
    If SHOWERRORS Then On Error Resume Next
    If Instr(mb0, "@") = 0 Then
      objNameTranslate.Set 3, strDomain & "\" & mb0 ' ADS_NAME_TYPE_NT4
    Else
      objNameTranslate.Set 9, mb0 ' ADS_NAME_TYPE_USER_PRINCIPAL_NAME
    End If
    myErrNumber = Err.Number
    If Err.Number <> 0 Then debugWrite "Error: " & Err.Number & " " & Err.Description & BRTEXT
    If SHOWERRORS Then On Error Goto 0
    If myErrNumber = 0 Then strDistinguishedName = objNameTranslate.Get(1) ' ADS_NAME_TYPE_1779
  End If

  If strDistinguishedName = "" Then
    debugWrite "Getting distinguished name via " & strGCProtocol & BRTEXT
    Set objConn = Server.CreateObject("ADODB.Connection")
    objConn.Provider = "ADsDSOObject"
    objConn.Properties("ADSI Flag") = 33 ' 1
    If Not CUSTOMFBA Then
      objConn.Open "ADs Provider"
    Else
      objConn.Open "ADs Provider", strUserName, strPassword
    End If
    Set objCmd = Server.CreateObject("ADODB.Command")
    objCmd.ActiveConnection = objConn
    strSQL = "<" & strGCProtocol & strLDAPPath & ">;(sAMAccountName=" & mb0 & ");distinguishedname"
    objCmd.CommandText = strSQL
    If SHOWERRORS Then On Error Resume Next
    Set objRs = objCmd.Execute
    If Not(objRs.BOF And objRs.EOF) Then strDistinguishedName = objRs("distinguishedname")
    If SHOWERRORS Then On Error Goto 0
    Set objRs = Nothing : Set objCmd = Nothing
    objConn.Close : Set objConn = Nothing
  End If

  If IsArray(strDistinguishedName) Then
    s = strDistinguishedName(0)
    strDistinguishedName = s
  End If

  strDistinguishedName = Replace(strDistinguishedName, "/", "\/")

  If strDistinguishedName <> "" Then
    debugWrite ">> " & strDistinguishedName & BRTEXT
    If SHOWERRORS Then On Error Resume Next
    If Not CUSTOMFBA Then
      Set objUser = GetObject(strGCProtocol & strDistinguishedName)
    Else
      Set dso = GetObject("LDAP:")
      Set objUser = dso.OpenDSObject(strGCProtocol & strDistinguishedName, strDomainAndUserName, strPassword, &H220) ' ADS_SECURE_AUTHENTICATION + ADS_FAST_BIND
    End If
    debugWrite "Home Server Name = "
    If SERVERNAME = "" Then
      strHomeServer = objUser.msExchHomeServerName
      If strHomeServer <> "" Then
        p = InstrRev(strHomeServer, "cn=")
        strHomeServer = Right(strHomeServer, (Len(strHomeServer) - (p - 1)) - Len("cn="))
      End If
    Else
      strHomeServer = SERVERNAME
      debugWrite "(forced) "
    End If
    debugWrite strHomeServer & BRTEXT
    If strHomeServer <> "" Then
      arrProtocolSettings = objUser.protocolSettings
      If (VarType(arrProtocolSettings) And vbArray) <> 0 Then
        For i = LBound(arrProtocolSettings) To UBound(arrProtocolSettings)
          s = arrProtocolSettings(i)
          If Left(UCase(s), 4) = "HTTP" Then If Mid(s, 6, 1) = "0" Then rwbc HTTPDISABLEDFORMAILBOXTEXT : errorCode = 1
        Next
      End If
      If CHECKUSEROMAENABLED Then
        v = ""
        If SHOWERRORS Then On Error Resume Next
        v = objUser.msExchOmaAdminWirelessEnable
        myErrNumber = Err.Number
        If SHOWERRORS Then On Error Goto 0
        If myErrNumber = 0 Then
          If IsNumeric(v) Then If (v And 2) <> 0 Then rwbc OMADISABLEDFORMAILBOXTEXT : errorCode = 1
        End If
      End If
    Else
      rwbc "Can't get msExchHomeServerName for '" & mb0 & "' from Active Directory using " & strGCProtocol & BRTEXT & vbCrLf & _
       "Try setting a value in Define.inc :" & BRTEXT & vbCrLf & _
       "1. CONST GCPROTOCOLSTRING = ""LDAP://""" & BRTEXT & vbCrLf & _
       "or 2. CONST SERVERNAME = &lt;your exchange server name&gt;" & BRTEXT
      errorCode = 1
    End If
    Set objUser = Nothing : If CUSTOMFBA Then Set dso = Nothing
  Else
    debugWrite "Can't find " & mb0 & " in Active Directory"
  End If

End Sub

Sub loginGetAccount

  Dim dso, objCmd, objConn, objRs, objUser, p, s, strDN

  debugWrite "Getting Account for " & strLogonUser & BRTEXT

  'strAccount = strDomainAndUserName
  strAccount = strDomain & "\" & strUserName

  If Not(objNameTranslate Is Nothing) Then
    If SHOWERRORS Then On Error Resume Next
    If Instr(strLogonUser, "@") = 0 Then
      objNameTranslate.Set 3, strDomainAndUserName ' ADS_NAME_TYPE_NT4
    Else
      objNameTranslate.Set 9, strLogonUser ' ADS_NAME_TYPE_USER_PRINCIPAL_NAME
    End If
    If Err.Number <> 0 Then debugWrite "Error: " & Err.Number & " " & Err.Description & BRTEXT
    myErrNumber = Err.Number
    If SHOWERRORS Then On Error Goto 0
    If myErrNumber = 0 Then strDN = objNameTranslate.Get(1) ' ADS_NAME_TYPE_1779
  End If

  If strDN = "" Then
    debugWrite "Getting distinguished name via " & strGCProtocol & BRTEXT
    Set objConn = Server.CreateObject("ADODB.Connection")
    objConn.Provider = "ADsDSOObject"
    objConn.Properties("ADSI Flag") = 33 ' 1
    If Not CUSTOMFBA Then
      objConn.Open "ADs Provider"
    Else
      objConn.Open "ADs Provider", strUserName, strPassword
    End If
    Set objCmd = Server.CreateObject("ADODB.Command")
    objCmd.ActiveConnection = objConn
    strSQL = "<" & strGCProtocol & strLDAPPath & ">;(sAMAccountName=" & strUserName & ");distinguishedname"
    objCmd.CommandText = strSQL
    If SHOWERRORS Then On Error Resume Next
    Set objRs = objCmd.Execute
    If Not(objRs.BOF And objRs.EOF) Then strDN = objRs("distinguishedname")
    If SHOWERRORS Then On Error Goto 0
    objConn.Close : Set objRs = Nothing : Set objCmd = Nothing : Set objConn = Nothing
  End If

  If IsArray(strDN) Then
    s = strDN(0)
    strDN = s
  End If

  strDN = Replace(strDN, "/", "\/")

  If strDN <> "" Then
    If SHOWERRORS Then On Error Resume Next
    If Not CUSTOMFBA Then
      Set objUser = GetObject(strGCProtocol & strDN)
    Else
      Set dso = GetObject("LDAP:")
      Set objUser = dso.OpenDSObject(strGCProtocol & strDN, strDomainAndUserName, strPassword, &H220) ' ADS_SECURE_AUTHENTICATION + ADS_FAST_BIND
    End If
    errNumber = Err.Number
    strUPN = objUser.userPrincipalName
    strAccount2 = strUPN
    Set objUser = Nothing : If CUSTOMFBA Then Set dso = Nothing
    If SHOWERRORS Then On Error Goto 0
    If errNumber <> 0 Then debugWrite "GetObject(" & strGCProtocol & strDN & ") fails" & BRTEXT
  End If

  If strAccount2 = "" Then strAccount2 = strAccount
  debugWrite ">> " & strAccount & " + " & strAccount2 & BRTEXT

End Sub

Sub loginGetCDOTimeZone

  lastTz0 = getPref("lastTz0", False)
  If tz0 <> lastTz0 Then
    locFound = False
    Set locFso = Server.CreateObject("Scripting.FileSystemObject")
    Set locF = locFso.OpenTextFile(Server.MapPath("TimeZones.txt"))
    Do While Not locF.AtEndOfStream
      locT = locF.ReadLine
      If locT <> "" Then
        locArrT = Split(locT, ",")
        If UCase(locArrT(0)) = UCase(tz0) Then locT2 = locArrT(1) : locFound = True
      End If
    Loop
    locF.Close
    Set locF = Nothing : Set locFso = Nothing
    If locFound Then
      tz1 = locT2
      setPref "tz1", tz1
      lastTz0 = tz0
      setPref "lastTz0", lastTz0
    Else
      rwbc "Can't match Time Zone - " & tz0: errorCode = 1
    End If
  Else
    tz1 = getPref("tz1", False)
  End If

End Sub

Sub loginGetCredentials

  Dim objInfoAD, p
  If Not CUSTOMFBA Then
    strLogonUser = Request.ServerVariables("LOGON_USER")
    strPassword = Request.ServerVariables("AUTH_PASSWORD")
  Else
    If Session("OPWLOGON") = "Y" Then
      strLogonUser = Request("un0")
      strPassword = Request("pw0")
      If (strLogonUser = "") Or (strPassword = "") Then
        doLogonLink
        errorCode = 2
      End If
    ElseIf Session("OPWLOGON") = "" Then
      doLogonLink
      errorCode = 2
    Else
      strLogonUser = Session("OPWLOGONUSER")
      If Request("pw0") = "" Then
        strPassword = Session("OPWLOGON")
      Else
        strPassword = Request("pw0")
      End If
    End If
    If mb0 = "" Then
      mb0 = strLogonUser
      mb0 = Replace(mb0, "/", "\")
      p = Instr(mb0, "\")
      If p <> 0 Then mb0 = Right(mb0, Len(mb0) - p)
    'Else
    '  mb0 = Request.Form("mb0")
    End If
  End If
  strLogonUser = Replace(strLogonUser, "/", "\")
  debugWrite "strLogonUser = " & strLogonUser & BRTEXT
  debugWrite "strPassword = "
  If strPassword <> "" Then
    debugWrite "(exists)" & BRTEXT
  Else
    debugWrite "(empty)" & BRTEXT
  End If

  debugWrite "Getting NT Domain name" & BRTEXT
  p = Instr(strLogonUser, "\")
  If p <> 0 Then
    strDomain = Left(strLogonUser, p - 1)
  Else
    p = Instr(strLogonUser, "@")
    If p <> 0 Then strDomain = Right(strLogonUser, Len(strLogonUser) - p)
  End If
  If strDomain = "" Then
    debugWrite "Not found in LOGON_USER"
    If DEFAULTDOMAIN = "" Then
      debugWrite " - trying ADSystemInfo" & BRTEXT
      If SHOWERRORS Then On Error Resume Next
      Set objInfoAD = Server.CreateObject("ADSystemInfo")
      strDomain = objInfoAD.DomainShortName
      Set objInfoAD = Nothing
      If strDomain = "" Then
        debugWrite "ADSystemInfo fails - trying GetObject" & BRTEXT
        strDomain = GetObject(strGCProtocol & strLDAPPath).dc
      End If
      If SHOWERRORS Then On Error Goto 0
    Else
      debugWrite " - using DEFAULTDOMAIN" & BRTEXT
      strDomain = DEFAULTDOMAIN
    End If
  End If
  debugWrite ">> " & strDomain & BRTEXT

  debugWrite "Getting NT User name" & BRTEXT
  p = Instr(strLogonUser, "\")
  If p <> 0 Then
    strUserName = Right(strLogonUser, Len(strLogonUser) - p)
  Else
    p = Instr(strLogonUser, "@")
    If p <> 0 Then
      strUserName = Left(strLogonUser, p - 1)
    Else
      strUserName = strLogonUser
    End If
  End If
  debugWrite ">> " & strUserName & BRTEXT

  If Instr(strLogonUser, "@") = 0 Then
    If strDomain <> "" Then
      strDomainAndUserName = strDomain & "\" & strUserName
    Else
      strDomainAndUserName = strUserName
    End If
  Else
    strDomainAndUserName = strLogonUser
  End If
  debugWrite ">> " & strDomainAndUserName & BRTEXT

End Sub

Sub loginGetLDAPPaths

  Dim objRoot
  If GCPROTOCOLSTRING = "" Then
    strGCProtocol = "GC://"
  Else
    strGCProtocol = GCPROTOCOLSTRING
  End If
  debugWrite "GC Provider string = " & strGCProtocol & BRTEXT
  If LDAPPROTOCOLSTRING = "" Then
    strLDAPProtocol = "LDAP://"
  Else
    strLDAPProtocol = LDAPPROTOCOLSTRING
  End If
  debugWrite "LDAP Provider string = " & strLDAPProtocol & BRTEXT
  debugWrite "Getting LDAP Paths" & BRTEXT
  Set objRoot = GetObject(strGCProtocol & "RootDSE")
  strLDAPPath = objRoot.Get("defaultNamingContext")
  'strLDAPPath = objRoot.Get("rootDomainNamingContext")
  strLDAPConfigPath = objRoot.Get("configurationNamingContext")
  Set objRoot = Nothing
  If (strLDAPPath <> "") And (strLDAPConfigPath <> "") Then
    debugWrite ">> " & strLDAPPath & " + " & strLDAPConfigPath & BRTEXT
  Else
    rwbc "Can't get LDAP Paths" : errorCode = 1
  End If

End Sub

Sub loginGetMailboxParams

  debugWrite "Getting Mailbox Params" & BRTEXT
  strXML = "<a:propfind " & strXMLNS & "><a:prop>" & _
     "<d:timezone/><j:calendar/><j:contacts/><j:deleteditems/><j:drafts/><j:inbox/><j:notes/><j:outbox/><j:sentitems/><j:tasks/>" & _
   "</a:prop></a:propfind>"
  strStatus = doWinHTTPSend("PROPFIND", strMailboxURL, strXML)
  If Left(strStatus, 1) = "2" Then
    tz0 = getXMLNode("http://schemas.microsoft.com/exchange/", "timezone")
    strCalendarURL = loginGetMailboxParams2("calendar")
    strContactsURL = loginGetMailboxParams2("contacts")
    strDeletedItemsURL = loginGetMailboxParams2("deleteditems")
    strDraftsURL = loginGetMailboxParams2("drafts")
    strInboxURL = loginGetMailboxParams2("inbox")
    strNotesURL = loginGetMailboxParams2("notes")
    strOutboxURL = loginGetMailboxParams2("outbox")
    strSentItemsURL = loginGetMailboxParams2("sentitems")
    strTasksURL = loginGetMailboxParams2("tasks")
  End If

End Sub

Function loginGetMailboxParams2(inParam)
  locT = getXMLNode("urn:schemas:httpmail:", inParam)
  If locT <> "" Then loginGetMailboxParams2 = Right(locT, Len(locT) - Len(strMailboxURL)) & "/"
End Function

Sub loginGetMbFolder

  Dim dso, i, objUser, p, s, s2, strResponse, strStatus, strURL
  debugWrite "Getting mailbox folder URL" & BRTEXT
  If SHOWERRORS Then On Error Resume Next
  If Not CUSTOMFBA Then
    Set objUser = GetObject(strGCProtocol & strDistinguishedName)
  Else
    Set dso = GetObject("LDAP:")
    Set objUser = dso.OpenDSObject(strGCProtocol & strDistinguishedName, strDomainAndUserName, strPassword, &H220) ' ADS_SECURE_AUTHENTICATION + ADS_FAST_BIND
  End If
  strDisplayName = objUser.displayName
  arrProxyAddresses = objUser.proxyAddresses
  If Not(IsArray(arrProxyAddresses)) Then
    debugWrite "proxyAddresses is empty, using '" & strUPN & "'" & BRTEXT
    arrProxyAddresses = Array(strUPN)
  End If

  strMailboxURL = ""
  debugWrite "Trying default SMTP address" & BRTEXT
  s = getDefaultProxyAddress(arrProxyAddresses)
  strSMTPAddress = s
  debugWrite s & BRTEXT
  s2 = s
  p = Instr(s, "@") : If p <> 0 Then s = Left(s, p - 1)
  strURL = strExchangeURL & s & "/" : debugWrite "GET " & strURL
  strStatus = doWinHTTPGet(strURL, "f") : debugWrite " (" & strStatus & ")" & BRTEXT
  If Left(strStatus, 1) = "2" Then
    strResponse = objWinHTTP.ResponseText
    If Instr(Ucase(strResponse), "OWAAUTH.DLL") = 0 Then
      strMailboxURL = strURL
    Else
      debugWrite "(other user)" & BRTEXT
    End If
  Else
    strURL = strExchangeURL & s2 & "/" : debugWrite "GET " & strURL
    strStatus = doWinHTTPGet(strURL, "f") : debugWrite " (" & strStatus & ")" & BRTEXT
    If Left(strStatus, 1) = "2" Then
      strResponse = objWinHTTP.ResponseText
      If Instr(Ucase(strResponse), "OWAAUTH.DLL") = 0 Then
        strMailboxURL = strURL
      Else
        debugWrite "(other user)" & BRTEXT
      End If
    End If
  End If
  If strmailboxURL = "" Then
    debugWrite "Trying other SMTP addresses" & BRTEXT
    For i = LBound(arrProxyAddresses) To UBound(arrProxyAddresses)
      s = arrProxyAddresses(i)
      If Left(s, 5) = "smtp:" Then
        debugWrite s & BRTEXT
        s = Right(s, Len(s) - 5)
        s2 = s
        p = Instr(s, "@") : If p <> 0 Then s = Left(s, p - 1)
        strURL = strExchangeURL & s & "/" : debugWrite "GET " & strURL
        strStatus = doWinHTTPGet(strURL, "f") : debugWrite " (" & strStatus & ")" & BRTEXT
        If Left(strStatus, 1) = "2" Then
          strResponse = objWinHTTP.ResponseText
          If Instr(Ucase(strResponse), "OWAAUTH.DLL") = 0 Then
            strMailboxURL = strURL
          Else
            debugWrite "(other user)" & BRTEXT
          End If
        Else
          strURL = strExchangeURL & s2 & "/" : debugWrite "GET " & strURL
          strStatus = doWinHTTPGet(strURL, "f") : debugWrite " (" & strStatus & ")" & BRTEXT
          If Left(strStatus, 1) = "2" Then
            strResponse = objWinHTTP.ResponseText
            If Instr(Ucase(strResponse), "OWAAUTH.DLL") = 0 Then
              strMailboxURL = strURL
            Else
              debugWrite "(other user)" & BRTEXT
            End If
          End If
        End If
      End If
      If strMailboxURL <> "" Then Exit For
    Next
  End If
  If strMailboxURL = "" Then errorCode = 1
  Set objUser = Nothing : If CUSTOMFBA Then Set dso = Nothing

  If PUBLICFOLDERSSERVER = "" Then
    strPublicURL = strServerURL & "Public/"
  Else
    If UCase(Left(PUBLICFOLDERSSERVER, 4)) <> "HTTP" Then
      strPublicURL = strProtocol & "://" & PUBLICFOLDERSSERVER & "/Public/"
    Else
      strPublicURL = PUBLICFOLDERSSERVER & "/Public/"
    End If
  End If

  debugWrite ">> " & strMailboxURL & " + " & strPublicURL & BRTEXT

End Sub

Sub loginGetObjects

  Dim objInfoAD, p, strDC
  Set objWinHTTP = Server.CreateObject("WinHTTP.WinHTTPRequest.5.1")
  objWinHTTP.SetAutoLogonPolicy 0
  objWinHTTP.Option(4) = &H3300 ' Option_SSLErrorIgnoreFlags = SslErrorFlag_Ignore_All
  objWinHTTP.Option(6) = False ' Option_EnableRedirects
  objWinHTTP.SetTimeOuts -1, -1, -1, -1
  Set objWinHTTP2 = Server.CreateObject("WinHTTP.WinHTTPRequest.5.1")
  objWinHTTP2.SetAutoLogonPolicy 0
  objWinHTTP2.Option(4) = &H3300 ' Option_SSLErrorIgnoreFlags = SslErrorFlag_Ignore_All
  objWinHTTP2.Option(6) = False ' Option_EnableRedirects
  objWinHTTP2.SetTimeOuts -1, -1, -1, -1
  Set objNameTranslate = Server.CreateObject("NameTranslate")
  If SHOWERRORS Then On Error Resume Next
  If Not CUSTOMFBA Then
    objNameTranslate.Init 3, ""
  Else
    objNameTranslate.InitEx 3, "", strUserName, "", strPassword ' ADS_NAME_INITTYPE_GC
  End If
  If Err.Number <> 0 Then
    debugWrite "ADS_NAME_INITTYPE_GC fails - " & Err.Number & " - " & Err.Description & BRTEXT
    Err.Clear
    If Not CUSTOMFBA Then
      objNameTranslate.Init 1, strDomain
    Else
      objNameTranslate.InitEx 1, strDomain, strUserName, "", strPassword ' ADS_NAME_INITTYPE_DOMAIN
    End If
    If Err.Number <> 0 Then
      debugWrite "ADS_NAME_INITTYPE_DOMAIN fails - " & Err.Number & " - " & Err.Description & BRTEXT
      Err.Clear
      If Not CUSTOMFBA Then
        objNameTranslate.Init 2, strDC
      Else
        Set objInfoAD = Server.CreateObject("ADSystemInfo")
        strDC = objInfoAD.GetAnyDCName()
        Set objInfoAD = Nothing
        objNameTranslate.InitEx 2, strDC, strUserName, "", strPassword ' ADS_NAME_INITTYPE_SERVER
      End If
      If Err.Number <> 0 Then
        debugWrite "ADS_NAME_INITTYPE_SERVER fails - " & Err.Number & " - " & Err.Description & BRTEXT
        Err.Clear
        Set objNameTranslate = Nothing
        debugWrite "Can't initialize NameTranslate object" & BRTEXT
      End If
    End If
  End If
  If SHOWERRORS Then On Error Goto 0

End Sub

Sub loginGetPrefsMessage

  debugWrite "Finding Prefs Message" & BRTEXT
  strPrefsMessageSubject = APPNAME & " USER PREFS"
  strXML = "<a:propfind " & strXMLNS & "><a:prop><j:textdescription/></a:prop></a:propfind>"
  strStatus = doWinHTTPSend("PROPFIND", strMailboxURL & strInboxURL & strPrefsMessageSubject & ".EML", strXML)
  If Left(strStatus, 1) = "2" Then
    strPrefsText = getXMLNode("urn:schemas:httpmail:", "textdescription")
  Else
    debugWrite "Creating Prefs Message" & BRTEXT
    strXML = "<a:propertyupdate " & strXMLNS & "><a:set><a:prop>" & _
       "<a:ishidden>1</a:ishidden>" & _
       "<g:x67aa000b>1</g:x67aa000b>" & _
       "<j:subject>" & strPrefsMessageSubject & "</j:subject>" & _
     "</a:prop></a:set></a:propertyupdate>"
    doWinHTTPSend "PROPPATCH", strMailboxURL & strInboxURL & strPrefsMessageSubject & ".EML", strXML
    strPrefsText = ""
  End If
  If Not blnNoRequests Then If Request.Form("resetPrefs") = "Y" Then strPrefsText = ""

End Sub

Sub loginGetProtocol

  Dim strLocation
  debugWrite "Getting server protocol" & BRTEXT
  If (PORTNUMBER <> "") And (PORTNUMBER <> "80") And (PORTNUMBER <> "443") Then strPortNumber = ":" & PORTNUMBER
  If Not FORCEHTTPS Then
    strProtocol = "http"
    strURL = strProtocol & "://" & strHomeServer & strPortNumber & "/" & strExchangeVDir
    strStatus = doWinHTTPGet(strURL, "f")
    debugWrite "GET " & strURL & " (" & strStatus & ") " & BRTEXT
    If strStatus = "403" Then strProtocol = "https"
    ' Has an automatic http -> https redirect been configured?
    If strStatus = "302" Then
      strLocation = objWinHTTP.GetResponseHeader("Location")
      If UCase(Left(strLocation, 8)) = "HTTPS://" Then
        debugWrite "(detected redirection) " & BRTEXT
        strProtocol = "https"
      End If
    End If
  Else
    debugWrite "(https forced) " & BRTEXT
    strProtocol = "https"
  End If
  If strProtocol = "https" Then
    strURL = strProtocol & "://" & strHomeServer & strPortNumber & "/" & strExchangeVDir
    strStatus = doWinHTTPGet(strURL, "f")
  End If
  strResponse = objWinHTTP.ResponseText
  'rwbc displayEncode0(strResponse)
  If Instr(UCase(strResponse), "OWAAUTH.DLL") <> 0 Then
    debugWrite "FBA detected" & BRTEXT
    'strProtocol = "https"
    locTxt = "destination=" & Server.URLEncode("http://" & strHomeServer & strPortNumber & "/" & strExchangeVDir) & _
     "&flags=0" & _
     "&username=" & strAccount & _
     "&password=" & strPassword & _
     "&SubmitCreds=Log+On" & _
     "&forcedownlevel=0" & _
     "&trusted=0"
    ' Use doWinHTTPSend1 so that any redirects are not followed
    doWinHTTPSend1 "POST", strProtocol & "://" & strHomeServer & strPortNumber & "/exchweb/bin/auth/owaauth.dll", locTxt
    locT = objWinHTTP.GetAllResponseHeaders
    locArrT = Split(locT, vbCrLf)
    For locN = LBound(locArrT) To UBound(locArrT)
      locT2 = locArrT(locN)
      locArrT2 = Split(locT2, ":")
      If UBound(locArrT2) = 1 Then
        If UCase(locArrT2(0)) = "SET-COOKIE" Then
          locT3 = Trim(locArrT2(1))
          If Left(UCase(locT3), 9) = "SESSIONID" Then
            strSessionid = locT3
          ElseIf Left(UCase(locT3), 6) = "CADATA" Then
            strCadata = locT3
          End If
        End If
      End If
    Next
  End If
  debugWrite ">> " & strProtocol & BRTEXT

End Sub

Sub loginGetStatusMessage

  If si0 = "" Then

    debugWrite "Application status messages:" & BRTEXT
    strXML = "<a:searchrequest " & strXMLNS & "><a:sql>" & _
       "SELECT ""DAV:creationdate""" & _
       " FROM scope('shallow traversal of """ & strMailboxURL & strInboxURL & """')" & _
       " WHERE ""DAV:ishidden"" = True" & _
       " AND ""DAV:displayname"" LIKE '" & APPNAME & " USER STATUS%'" & _
     "</a:sql></a:searchrequest>"
    strStatus = doWinHTTPSearch(strMailboxURL & strInboxURL, strXML, "")
    If Left(strStatus, 1) = "2" Then
      locArrT = getXMLNodes("DAV:", "creationdate")
      locArrT2 = getXMLNodes("DAV:", "href")
      If SHOWERRORS Then On Error Resume Next
      locD = UBound(locArrT)
      errNumber = Err.Number
      If SHOWERRORS Then On Error Goto 0
      If errNumber = 0 Then
        For locN = LBound(locArrT) To UBound(locArrT)
          locCreated = getDateTimeFromTZ(locArrT(locN))
          locDateDiff = DateDiff("h", Now, locCreated)
          debugWrite locCreated & " - " & locDateDiff & "hrs"
          If locDateDiff < -24 Then
            debugWrite " - will delete"
            doWinHTTPSend "DELETE", locArrT2(locN), ""
          End If
          debugWrite BRTEXT
        Next
      End If
    End If

    debugWrite "Creating Status Message" & BRTEXT
    Randomize
    si0 = Int(100000 * Rnd)
    strStatusMessageSubject = APPNAME & " USER STATUS " & si0
    strXML = "<a:propertyupdate " & strXMLNS & "><a:set><a:prop>" & _
       "<a:ishidden>1</a:ishidden>" & _
       "<g:x67aa000b>1</g:x67aa000b>" & _
       "<j:subject>" & strStatusMessageSubject & "</j:subject>" & _
     "</a:prop></a:set></a:propertyupdate>"
    doWinHTTPSend "PROPPATCH", strMailboxURL & strInboxURL & strStatusMessageSubject & ".EML", strXML
    strParamsText = ""

    If CUSTOMFBA And (si0 <> "") Then
      Session("OPWLOGONUSER") = strLogonUser
      Session("OPWLOGON") = strPassword
    End If

  Else

    debugWrite "Finding Status Message" & BRTEXT
    strStatusMessageSubject = APPNAME & " USER STATUS " & si0
    strXML = "<a:propfind " & strXMLNS & "><a:prop><j:textdescription/></a:prop></a:propfind>"
    strStatus = doWinHTTPSend("PROPFIND", strMailboxURL & strInboxURL & strStatusMessageSubject & ".EML", strXML)
    If Left(strStatus, 1) = "2" Then
      strParamsText = getXMLNode("urn:schemas:httpmail:", "textdescription")
    Else
      rwbc "Can't find Status Message" : strStatusMessageSubject = "" : errorCode = 1
    End If

  End If

End Sub

Sub loginGetTimeConverter

  Dim d, x
  blnCDOApptExists = False
  If SHOWERRORS Then On Error Resume Next
  Set objConvertAppointment = Server.CreateObject("CDO.Appointment")
  If Err.Number = 0 Then
    Set objConvertConfiguration = Server.CreateObject("CDO.Configuration")
    objConvertAppointment.Configuration = objConvertConfiguration
    objConvertConfiguration.Fields("urn:schemas:calendar:timezoneid") = 0
    If Err.Number = 0 Then blnCDOApptExists = True
  End If
  debugWrite "CDO.Appointment created >> " & blnCDOApptExists & BRTEXT
  If SHOWERRORS Then On Error Goto 0
  d = getTZFromDateTime(dateAdd("yyyy", -10, Now))
  x = "<a:propertyupdate " & strXMLNS & "><a:set><a:prop>" & _
     "<a:contentclass>urn:content-classes:appointment</a:contentclass>" & _
     "<a:ishidden>1</a:ishidden>" & _
     "<d:outlookmessageclass>IPM.Appointment</d:outlookmessageclass>" & _
     "<g:x67aa000b>1</g:x67aa000b>" & _
     "<h:dtend>" & d & "</h:dtend>" & _
     "<h:dtstart>" & d & "</h:dtstart>" & _
     "<j:subject>OWA FOR PDA AND WAP TIME CONVERTER</j:subject>" & _
   "</a:prop></a:set></a:propertyupdate>"
  doWinHTTPSend "PROPPATCH", strMailboxURL & strCalendarURL & "OWA FOR PDA AND WAP TIME CONVERTER.EML", x

End Sub

Sub logoff

  Dim x
  If IsObject(objWinHTTP) Then
    If strPrefsMessageSubject <> "" Then
      x = "<a:propertyupdate " & strXMLNS & "><a:set><a:prop>" & _
         "<j:textdescription>" & displayEncodeX0(strPrefsText) & "</j:textdescription>" & _
       "</a:prop></a:set></a:propertyupdate>"
      doWinHTTPSend "PROPPATCH", strMailboxURL & strInboxURL & strPrefsMessageSubject & ".EML", x
    End If
    If strStatusMessageSubject <> "" Then
      x = "<a:propertyupdate " & strXMLNS & "><a:set><a:prop>" & _
         "<j:textdescription>" & displayEncodeX0(strParamsText) & "</j:textdescription>" & _
       "</a:prop></a:set></a:propertyupdate>"
      doWinHTTPSend "PROPPATCH", strMailboxURL & strInboxURL & strStatusMessageSubject & ".EML", x
    End If
    doWinHTTPSend "DELETE", strMailboxURL & strCalendarURL & "OWA FOR PDA AND WAP TIME CONVERTER.EML", ""
    Set objWinHTTP = Nothing
  End If
  If IsObject(objWinHTTP2) Then Set objWinHTTP2 = Nothing
  If IsObject(objNameTranslate) Then Set objNameTranslate = Nothing
  If blnCDOApptExists Then
    If IsObject(objConvertAppointment) Then Set objConvertAppointment = Nothing
    If IsObject(objConvertConfiguration) Then Set objConvertConfiguration = Nothing
  End If

End Sub

Function myUTF8ToAsciiB(inString)

  Dim b, b2, c, c2, c3, c4, c5, c6, i, i2, l, n, n2, n3, n4, n5, n6, s, t
  s = "" : l = LenB(inString) : i = 1 : b = False
  Do While i <= l
    If AscB(MidB(inString, i, 1)) > 127 Then : b = True : Exit Do
    i = i + 2
  Loop
  If b Then
    s = Left(inString, (i - 1) / 2)
    s = Server.HTMLEncode(s)
    b2 = False
    Do While (i <= l) And (Not b2)
      c = MidB(inString, i, 1) : n = AscB(c)
      i2 = 0
      If n >= 192 Then
        If n <= 223 Then
          If i <= (l - 2) Then
            c2 = MidB(inString, i + 2, 1) : n2 = AscB(c2)
            If (n2 And &HC0) = &H80 Then
              t = (n - 192) * 64 + (n2 - 128)
              i2 = 2
            Else
              b2 = True ' Error - not UTF-8
            End If
          End If
        ElseIf n <= 239 Then
          If i <= (l - 4) Then
            c2 = MidB(inString, i + 2, 1) : n2 = AscB(c2) : c3 = MidB(inString, i + 4, 1) : n3 = AscB(c3)
            If ((n2 And &HC0) = &H80) And ((n3 And &HC0) = &H80) Then
              t = (n - 224) * 4096 + (n2 - 128) * 64 + (n3 - 128)
              i2 = 4
            Else
              b2 = True
            End If
          End If
        ElseIf n <= 247 Then
          If i <= (l - 6) Then
            c2 = MidB(inString, i + 2, 1) : n2 = AscB(c2) : c3 = MidB(inString, i + 4, 1) : n3 = AscB(c3)
            c4 = MidB(inString, i + 6, 1) : n4 = AscB(c4)
            If ((n2 And &HC0) = &H80) And ((n3 And &HC0) = &H80) And ((n4 And &HC0) = &H80) Then
              t = (n - 240) * 262144 + (n2 - 128) * 4096 + (n3 - 128) * 64 + (n4 - 128)
              i2 = 6
            Else
              b2 = True
            End If
          End If
        ElseIf n <= 251 Then
          If i <= (l - 8) Then
            c2 = MidB(inString, i + 2, 1) : n2 = AscB(c2) : c3 = MidB(inString, i + 4, 1) : n3 = AscB(c3)
            c4 = MidB(inString, i + 6, 1) : n4 = AscB(c4) : c5 = MidB(inString, i + 8, 1) : n5 = AscB(c5)
            If ((n2 And &HC0) = &H80) And ((n3 And &HC0) = &H80) And ((n4 And &HC0) = &H80) _
             And ((n5 And &HC0) = &H80) Then
              t = (n - 248) * 16777216 + (n2 - 128) * 262144 + (n3 - 128) * 4096 + (n4 - 128) * 64 + (n5 - 128)
              i2 = 8
            Else
              b2 = True
            End If
          End If
        ElseIf n <= 253 Then
          If i <= (l - 10) Then
            c2 = MidB(inString, i + 2, 1) : n2 = AscB(c2) : c3 = MidB(inString, i + 4, 1) : n3 = AscB(c3)
            c4 = MidB(inString, i + 6, 1) : n4 = AscB(c4) : c5 = MidB(inString, i + 8, 1) : n5 = AscB(c5)
            c6 = MidB(inString, i + 10, 1) : n6 = AscB(c6)
            If ((n2 And &HC0) = &H80) And ((n3 And &HC0) = &H80) And ((n4 And &HC0) = &H80) _
             And ((n5 And &HC0) = &H80) And ((n6 And &HC0) = &H80) Then
              t = (n - 252) * 1073741824 + (n2 - 128) * 16777216 + (n3 - 128) * 262144 + (n4 - 128) * 4096 + (n5 - 128) * 64 + (n6 - 128)
              i2 = 10
            Else
              b2 = True
            End If
          End If
        End If
      End If
      If i2 <> 0 Then
        s = s & "&#" & t & ";"
        i = i + i2
      Else
        s = s & Server.HTMLEncode(Chr(n))
      End If
      i = i + 2
    Loop
    If Not b2 Then
      myUTF8ToAsciiB = s
    Else
      myUTF8ToAsciiB = Server.HTMLEncode(inString)
    End If
  Else
    myUTF8ToAsciiB = Server.HTMLEncode(inString)
  End If

End Function

Function packText(inString, inLength)

  Dim c, c2, c3, i, l, l2, n, t, t2
  l = LenB(inString) : l2 = inLength : i = 1 : n = 1
  Do While (i <= l) And (n <= inLength)
    c = MidB(inString, i, 1) : t = AscB(c)
    If t >= 192 Then
      If t <= 223 Then
        If i <= (l - 2) Then
          c2 = MidB(inString, i + 2, 1) : t2 = AscB(c2)
          If (t2 And &HC0) = &H80 Then
            l2 = l2 + 1
            i = i + 2
          End If
        End If
      End If
    End If
    n = n + 1
    i = i + 2
  Loop
  c3 = " " : If ISWAP Then c3 = "_"
  packText = Left(inString & String(inLength, c3), l2)

End Function

Function prepareID(inID)

  Dim s
  s = inID
  If s <> "" Then
    If ISANORMVER Then s = Replace(s, "%", "#OPW%#")
  End If
  prepareID = s

End Function

Function recoverID(inID)

  Dim s
  s = inID
  If s <> "" Then
    If ISANORMVER Then s = Replace(s, "#OPW%#", "%")
  End If
  recoverID = s

End Function

Function resolveRecipients(inString)

  Dim arrS, arrTo, i, j, p, s, s2, strAddress, strName, strOut
  strOut = ""
  If inString <> "" Then
    arrTo = getAddresses(inString)
    For i = LBound(arrTo, 2) To UBound(arrTo, 2)
      strName = arrTo(0, i)
      strAddress = arrTo(1, i)
      If strName = "" Then strName = strAddress
      If strAddress = "" Then strAddress = strName
      rw displayEncode0(strName) & " - "
      If Instr(strAddress, "@") <> 0 Then
        strOut = addAddressToString(strOut, strName, strAddress)
        rwbc OKTEXT
      Else
        strXML = "<a:searchrequest xmlns:a=""DAV:""><a:sql>" & _
           "SELECT" & _
           " ""http://schemas.microsoft.com/mapi/dlmembers""" & _
           " FROM scope('shallow traversal of """ & strMailboxURL & strContactsURL & """')" & _
           " WHERE ""DAV:isfolder"" = False" & _
           " AND ""DAV:ishidden"" = False" & _
           " AND ""urn:schemas:httpmail:subject"" = '" & displayEncodeX0(strAddress) & "'" & _
         "</a:sql></a:searchrequest>"
        strStatus = doWinHTTPSend("SEARCH", strMailboxURL & strContactsURL, strXML)
        If Left(strStatus, 1) = "2" Then
          strURL = getXMLNode("DAV:", "href")
          If strURL <> "" Then
            strXML = "<a:propfind " & strXMLNS & "><a:prop><e:dloneoffmembers/></a:prop></a:propfind>"
            strStatus = doWinHTTPSend("PROPFIND", strURL, strXML)
            If Left(strStatus, 1) = "2" Then
              s = getXMLNode("http://schemas.microsoft.com/mapi/", "dloneoffmembers")
              s = Replace(s, "</c:v><c:v>", ",") : s = Replace(s, "</C:V><C:V>", ",")
              s = Replace(s, "<c:v>", "") : s = Replace(s, "<C:V>", "")
              s = Replace(s, "</c:v>", "") : s = Replace(s, "</C:V>", "")
              arrS = Split(s, ",")
              For j = 0 To UBound(arrS)
                s2 = base64DecodeSafe(arrS(j))
                p = Instr(UCase(s2), "SMTP")
                If p <> 0 Then
                  strAddress = Right(s2, (Len(s2) - (p - 1)) - 4)
                  strOut = addAddressToString(strOut, strAddress, strAddress)
                End If
              Next
              rwbc "(DL)"
            Else
              ' Add to recipients list anyway - just in case.
              strOut = addAddressToString(strOut, strName, strAddress)
              blnRecipientError = True
              rwbc ERRORTEXT
            End If
          Else
            ' Add to recipients list anyway - just in case.
            strOut = addAddressToString(strOut, strName, strAddress)
            blnRecipientError = True
            rwbc ERRORTEXT
          End If ' strURL <> ""
        End If ' If Left(strStatus, 1) = "2" Then
      End If ' If Instr(strTo, "@") <> 0 Then
    Next ' For i = 0 To UBound(arrTo)
  End If ' If inString <> "" Then
  resolveRecipients = strOut

End Function

Sub rw(inText) : Response.Write inText : End Sub

Sub rwbc(inText) : rwc inText & BRTEXT : End Sub

Sub rwc(inText) : rw inText & vbCrLf : End Sub

Function timeZoneGetOffset
  locT = getLocalDateTime(Now)
  locT2 = DateDiff("h", Now, locT)
  timeZoneGetOffset = locT2
End Function

Function timeZoneGetZone(inOffset)

  For locN = 0 To UBound(timeZoneOffsets) - 1
    If inOffset = timeZoneOffsets(locN) Then
      locT = timeZones(locN)
      Exit For
    End If
  Next
  timeZoneGetZone = locT

End Function

Function validDate(inDay, inMonth, inYear)
  locT = True
  If Int(inDay) > daysInMonth(inMonth, inYear) Then locT = False
  validDate = locT
End Function

Sub writeBody ' PDA only

  Dim arrT, f, fso, s, t, t2
  If (BODYCOLOR = "") And (TABLEROWCOLORA = "") And (TABLEROWCOLORB = "") Then
    If mb0 <> "" Then
      If Left(UCase(DEFAULTTHEME), 1) = "!" Then
        th0 = Right(DEFAULTTHEME, Len(DEFAULTTHEME) - 1)
      Else
        s = Request.Form("theme")
        If s <> "" Then setPref "th0", s
        th0 = getPref("th0", False)
        If (th0 = "") Or (th0 = "0") Then th0 = DEFAULTTHEME
      End If
      If th0 <> "" Then
        Set fso = Server.CreateObject("Scripting.FileSystemObject")
        Set f = fso.OpenTextFile(Server.MapPath("Themes.txt"))
        Do While Not f.AtEndOfStream
          t = f.ReadLine
          If (t <> "") And (Left(t, 1) <> "'") Then
            arrT = Split(t, ",")
            t2 = arrT(0)
            If t2 = th0 Then
              strBodyColour = arrT(1)
              strTableRowColourA = arrT(2)
              strTableRowColourB = arrT(3)
            End If
          End If
        Loop
        f.Close
        Set f = Nothing : Set fso = Nothing
      End If
    End If
  Else
    strBodyColour = BODYCOLOR : strTableRowColourA = TABLEROWCOLORA : strTableRowColourB = TABLEROWCOLORB
  End If
  rw "<body"
  If strBodyColour <> "" Then rw " bgcolor='" & strBodyColour & "'"
  If blnuseJavaScript Then
    Select Case UCase(strPageName)
      Case "MSE.ASP"
        If UCase(ac0) = "R" Then
          rw " onLoad='document.all.rs0.focus();'"
        End If
      Case "MSEM.ASP"
        If (mt0 And OPWMTMASK) = OPWCMN Then
          rw " onLoad='document.all.subject.focus();'"
        Else
          rw " onLoad='document.all.text.focus();'"
        End If
      Case "MSQ.asp"
        rw " onLoad='document.all.to.focus();'"
    End Select
  End If
  rwc ">"
  If (strFontFace <> "") Or (strFontSize <> "") Then
    rw "<font"
    If strFontFace <> "" Then rw " face='" & displayEncode0(strFontFace) & "'"
    If strFontSize <> "" Then rw " size='" & strFontSize & "'"
    rwc ">"
  End If
  If HEADERTEXT <> "" Then rwbc HEADERTEXT
  If centred Then rwc "<center>"
  If CUSTOMFBA And (Not CUSTOMFBASSL) Then
    rwbc "<font color=""red"">CUSTOMFBASSL should only be disabled during testing</font>"
  End If

End Sub

Sub writeDoGo(inTarget, inCaption) ' WAP only

  Dim p
  If doCounter = "" Then doCounter = 0
  doCounter = doCounter + 1
  If inTarget = "" Then
    inTarget = Request.ServerVariables("SCRIPT_NAME")
    p = InstrRev(inTarget, "/")
    If p <> 0 Then inTarget = Right(inTarget, Len(inTarget) - p)
  End If
  rwc "<anchor>" & displayEncodeI0(inCaption)
  Randomize
  rw "<go href='" & inTarget & "?mb0=" & displayEncodeI0(mb0) & "&amp;" & "si0=" & si0 & "&amp;" & "r=" & Int(100000 * Rnd)
  If blnDebug Then rw "&amp;" & "dbg=Y"
  rwc "' method='post'>"

End Sub

Sub writeDoGoEnd ' WAP only
  rwc "</go>"
  rwc "</anchor>&nbsp;"
End Sub

Sub writeForm(inTarget) ' PDA only

  If inTarget = "" Then
    inTarget = Request.ServerVariables("SCRIPT_NAME")
    p = InstrRev(inTarget, "/")
    If p <> 0 Then inTarget = Right(inTarget, Len(inTarget) - p)
  End If
  rwc "<form action='" & inTarget & "' method='post'>"
  rwc "<input type='hidden' name='mb0' value='" & displayEncodeI0(mb0) & "'>"
  rwc "<input type='hidden' name='si0' value='" & si0 & "'>"
  Randomize
  rwc "<input type='hidden' name='r' value='" & Int(100000 * Rnd) & "'>"
  If blnDebug Then rwc "<input type=""hidden"" name=""dbg"" value=""Y"">"

End Sub

Sub writeHeaders ' PDA only
  Response.Buffer = True
  Response.AddHeader "Cache-control", "no-cache, must-revalidate"
  rwc "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'>"
  rwc "<html>"
End Sub

Sub writeLinkWParams(inTarget, inTitle, inParamList)
  writeLinkWParams0 inTarget, displayEncodeI0(inTitle), inParamList
End Sub

Sub writeLinkWParams0(inTarget, inTitle, inParamList)

  Dim arrS, blnBold, blnFoundEm0, blnFoundVd0, blnNoBr, ci02, fi02, fi12, i, l, mi02, p, s, s2
  blnFoundEm0 = False
  s = inTarget
  If s = "" Then
    s = Request.ServerVariables("SCRIPT_NAME")
    p = InstrRev(s, "/")
    If p <> 0 Then s = Right(s, Len(s) - p)
  End If
  ci02 = prepareID(ci0)
  fi02 = prepareID(fi0)
  mi02 = prepareID(mi0)
  fi12 = prepareID(fi1)
  l = "<a href=""" & s & "?mb0=" & Server.URLEncode(mb0) & "&amp;" & "si0=" & si0

  blnBold = False : blnNoBr = False
  arrS = Split(UCase(inParamList), ",")
  For i = LBound(arrS) To UBound(arrS)
    s2 = Trim(arrS(i))
    Select Case s2
      Case "AC0" : writeLinkWParams02 l, "ac0", ac0
      Case "AD0" : writeLinkWParams02 l, "ad0", ad0
      Case "AT0" : writeLinkWParams02 l, "at0", at0
      Case "BOLD" : blnBold = True
      Case "CI0" : writeLinkWParams02 l, "ci0", ci02
      Case "DA0" : writeLinkWParams02 l, "da0", da0
      Case "DF0" : writeLinkWParams02 l, "df0", df0
      Case "FI0" : writeLinkWParams02 l, "fi0", fi02
      Case "FI1" : writeLinkWParams02 l, "fi1", fi12
      Case "FU0" : writeLinkWParams02 l, "fu0", fu0
      Case "KM0" : writeLinkWParams02 l, "km0", km0
      Case "MD0" : writeLinkWParams02 l, "md0", md0
      Case "MI0" : writeLinkWParams02 l, "mi0", mi02
      Case "MN0" : writeLinkWParams02 l, "mn0", mn0
      Case "MT0" : writeLinkWParams02 l, "mt0", mt0
      Case "NOBR" : blnNoBr = True
      Case "PG0" : writeLinkWParams02 l, "pg0", pg0
      Case "PG1" : writeLinkWParams02 l, "pg1", pg1
      Case "RE0" : writeLinkWParams02 l, "re0", re0
      Case "RY0" : writeLinkWParams02 l, "ry0", ry0
      Case "ST0" : writeLinkWParams02 l, "st0", st0
    End Select
    If Not ISWAP Then
      Select Case s2
        Case "AI0" : writeLinkWParams02 l, "ai0", ai0
        Case "CT0" : writeLinkWParams02 l, "ct0", ct0
        Case "DY0" : writeLinkWParams02 l, "dy0", dy0
        Case "EM0" : writeLinkWParams02 l, "em0", em0 : blnFoundEm0 = True
        Case "EM0Y" : blnFoundEm0 = True
        Case "HB0" : writeLinkWParams02 l, "hb0", hb0
        Case "MO0" : writeLinkWParams02 l, "mo0", mo0
        Case "VD0" : writeLinkWParams02 l, "vd0", vd0 : blnFoundVd0 = True
        Case "VD0Y" : blnFoundVd0 = True
        Case "YR0" : writeLinkWParams02 l, "yr0", yr0
      End Select
    Else
      Select Case s2
        Case "DT0" : writeLinkWParams02 l, "dt0", dt0
        Case "FN0" : writeLinkWParams02 l, "fn0", fn0
        Case "FN1" : writeLinkWParams02 l, "fn1", fn1
        Case "TZ2" : writeLinkWParams02 l, "tz2", tz2
        Case "TZ3" : writeLinkWParams02 l, "tz3", tz3
        Case "D_AL0" : writeLinkWParams03 l, "al0"
        Case "D_DT0" : writeLinkWParams03 l, "dt0"
        Case "D_FL0" : writeLinkWParams03 l, "fl0"
        Case "D_FL2" : writeLinkWParams03 l, "fl2"
        Case "D_FL3" : writeLinkWParams03 l, "fl3"
        Case "D_FN2" : writeLinkWParams03 l, "fn2"
        Case "D_MN0" : writeLinkWParams03 l, "mn0"
      End Select
    End If
  Next

  Randomize
  l = l & "&amp;" & "r=" & Int(100000 * Rnd)
  If blnDebug Then l = l & "&amp;" & "dbg=Y"
  l = l & """>"
  If blnBold Then l = l & "<b>"
  l = l & inTitle
  If blnBold Then l = l & "</b>"
  l = l & "</a>"
  If Not blnNoBr Then
    l = l & BRTEXT & vbCrLf
  Else
    l = l & "&nbsp;"
  End If
  If (em0 = "" Or blnFoundEm0) And (vd0 = "" Or blnFoundVd0) Then
    rw l
  End If

End Sub

Sub writeLinkWParams02(inLink, inParam, inValue)
  inLink = inLink & "&amp;" & inParam & "=" & Server.URLEncode(inValue)
End Sub

Sub writeLinkWParams03(inLink, inParam)
  inLink = inLink & "&amp;" & inParam & "=$(" & inParam & ")"
End Sub

Sub writeMailboxLink

  Dim s
  s = ""
  oldEm0 = em0 : oldVd0 = vd0
  If em0 <> "" Then em0 = "" : s = "EM0"
  If vd0 <> "" Then vd0 = "" : s = s & ",VD0"
  writeLinkWParams "MBX.asp", TOMAILBOXTEXT, s
  em0 = oldEm0 : vd0 = oldVd0

End Sub

Sub writePageEnd

  If Not ISWAP Then
    If centred Then rwc "</center>"
    If FOOTERTEXT <> "" Then rwbc FOOTERTEXT
    If (strFontFace <> "") Or (strFontSize <> "") Then rwc "</font>"
    rwc "</body>"
    rwc "</html>"
  Else
    rwc "</p>" & vbCrLf & "</card>" & vbCrLf & "</wml>"
  End If

End Sub

Sub writePageStart(inTitle)

  If SESSIONLCID <> "" Then Session.LCID = SESSIONLCID
  If Not ISWAP Then
    rwc "<head>"
    If CHARSET <> "" Then rwc "<meta http-equiv='Content-type' content='text/html; charset=" & CHARSET & "'>"
    If blnDoInboxRefresh Then
      'mb0 = Request.QueryString("mb0") : si0 = Request.QueryString("si0")
      Randomize
      rwc "<meta http-equiv='refresh'" & _
       " content='" & strRefreshMins * 60 & ";" & _
       " URL=" & _
       Request.ServerVariables("URL") & _
       "?mb0=" & Server.URLEncode(mb0) & "&amp;" & "si0=" & si0 & _
       "&amp;" & "r=" & Int(100000 * Rnd) & _
       "'>"
    End If
    If USECSS Then rwc "<link rel='StyleSheet' href='OWA-PDA.css' type='text/css'>"
    rw "<title>" & APPNAME
    If inTitle <> "" Then rw " - " & displayEncode0(inTitle)
    rwc "</title>"
    rwc "</head>"
  Else
    Response.ContentType = "text/vnd.wap.wml"
    Response.Buffer = True
    Response.AddHeader "Cache-control", "no-cache, must-revalidate"
    rwc "<?xml version='1.0'?>"
    rwc "<!DOCTYPE wml PUBLIC '-//WAPFORUM//DTD WML 1.1//EN' 'http://www.wapforum.org/DTD/wml_1.1.xml'>"
    rwc "<wml>"
    rw "<card title='" & displayEncode0(inTitle) & "' newcontext='true'"
    If gotoMailbox Or gotoInbox Then
      rw " ontimer='"
      If Not gotoInbox Then
        rw "MBX.asp"
      Else
        rw "MSL.asp"
      End If
      rw "?mb0=" & displayEncodeI0(mb0)
      If gotoInbox Then rw "&amp;fi0=OPWINBOX"
      If strDbg <> "" Then rw "&amp;dbg=" & strDbg
      rw "'"
    End If
    rwc ">"
    If gotoMailbox Or gotoInbox Then rwc "<timer value='1'/>"
    If centred Then
      rwc "<p align='center'>"
    Else
      rwc "<p>"
    End If
  End If

End Sub

Sub writeTable(inProps) ' PDA only
  If blnUseTables Then
    rw "<table cellspacing='0' cellpadding='0'"
    If inProps <> "" Then rw " " & inProps
    rwc ">"
  End If
End Sub

Sub writeTableEnd ' PDA only
  If blnUseTables Then rwc "</table>"
End Sub

Sub writeTd(inProps) ' PDA only
  If blnUseTables Then
    rw "<td"
    If inProps <> "" Then rw " " & inProps
    rw ">"
    If strFontSize <> "" Then rw "<font size='" & strFontSize & "'>"
  End If
End Sub

Sub writeTdEnd ' PDA only
  If blnUseTables Then
    If strFontSize <> "" Then rw "</font>"
    rwc "</td>"
  End If
End Sub

Sub writeTitle(inTitle)
  If Not ISWAP Then rw "<b>"
  rw displayEncode0(inTitle)
  If Not ISWAP Then rw "</b>"
  rwbc ""
End Sub

Sub writeTr(inProps) ' PDA only
  If blnUseTables Then
    rw "<tr"
    If inProps <> "" Then rw " " & inProps
    rwc ">"
  End If
End Sub

Sub writeTrEnd ' PDA only
  If blnUseTables Then
    rwc "</tr>"
  Else
    rwc BRTEXT
  End If
End Sub

Sub writeUnderline : rwc UNDERLINETEXT : End Sub
%>
